Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:48 2011
FILE NAME: arare_init-data.f90
PROGRAM NAME: arareinitdata
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   239  vec  (   4): Vectorized array expression.
   240  vec  (   4): Vectorized array expression.
   241  vec  (   4): Vectorized array expression.
   251  vec  (   4): Vectorized array expression.
   547  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   549  vec  (   4): Vectorized array expression.
   550  vec  (   4): Vectorized array expression.
   551  vec  (   4): Vectorized array expression.
   552  vec  (   4): Vectorized array expression.
   553  vec  (   4): Vectorized array expression.
   554  vec  (   4): Vectorized array expression.
   555  vec  (   4): Vectorized array expression.
   557  vec  (   4): Vectorized array expression.
   558  vec  (   4): Vectorized array expression.
   559  vec  (   4): Vectorized array expression.
   560  vec  (   4): Vectorized array expression.
   561  vec  (   4): Vectorized array expression.
   562  vec  (   4): Vectorized array expression.
   563  vec  (   4): Vectorized array expression.
   564  vec  (   4): Vectorized array expression.
   565  vec  (   4): Vectorized array expression.
   566  vec  (   4): Vectorized array expression.
   567  vec  (   4): Vectorized array expression.
   568  vec  (   4): Vectorized array expression.
   569  vec  (   4): Vectorized array expression.
   570  vec  (   4): Vectorized array expression.
   584  vec  (   1): Vectorized loop.
   601  vec  (   3): Unvectorized loop.
   603  vec  (   4): Vectorized array expression.
   613  vec  (   3): Unvectorized loop.
   614  vec  (   4): Vectorized array expression.
   614  vec  (   4): Vectorized array expression.
   629  vec  (   3): Unvectorized loop.
   630  vec  (   4): Vectorized array expression.
   630  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   644  vec  (   4): Vectorized array expression.
   644  vec  (   4): Vectorized array expression.
   654  vec  (   4): Vectorized array expression.
   654  vec  (   4): Vectorized array expression.
   663  vec  (   4): Vectorized array expression.
   663  vec  (   4): Vectorized array expression.
   674  vec  (   4): Vectorized array expression.
   674  vec  (   4): Vectorized array expression.
   688  vec  (   3): Unvectorized loop.
   689  vec  (   4): Vectorized array expression.
   689  vec  (   4): Vectorized array expression.
   901  vec  (   1): Vectorized loop.
   907  vec  (   4): Vectorized array expression.
   912  vec  (   2): Partially vectorized loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:48 2011
FILE NAME: arare_init-data.f90
PROGRAM NAME: arareinitdata
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Program ArareInitData
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro (̰ϯ), ODAKA Masatsugu ()
     4  ! Version::   $Id: arare_init-data.f90,v 1.19 2011-06-28 02:29:32 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  ! ϳإǥ deepconv/arare.
    12  !
    13  !== Error Handling
    14  !
    15  !== Known Bugs
    16  !
    17  !== Note
    18  !
    19  !  * ϤϽవ̷.
    20  !
    21  !== Future Plans
    22  !
    23  !
    24  
    25  program ArareInitData
    26    !
    27    !ϳإǥ deepconv/arare.
    28    !
    29  
    30    !----- ⥸塼ɤ߹ ------
    31  
    32    !-----   , ʸ   ----
    33    use dc_types,       only : STRING, DP
    34    use dc_string,      only : StoA
    35    use gtool_history,  only : HistoryPut
    36  
    37    !-----   å   -----
    38    use dc_message,     only: MessageNotify
    39  
    40    !  ޥɥ饤
    41    use argset,        only : argset_init
    42  
    43    !  MPI ν
    44    !  Initialize MPI wrapper
    45    !
    46    use mpi_wrapper,   only : MPIWrapperInit, MPIWrapperFinalize, myrank
    47  
    48    !-----    ⥸塼   -----
    49    !  ϥե̾⥸塼
    50    use fileset,    only : fileset_init
    51  
    52    !  ʻ⥸塼
    53    use gridset, only : gridset_init, &
    54      &                       imin, imax, jmin, jmax, kmin, kmax, &
    55      &                       nx, ny, nz,  ncmax
    56  
    57    !  ܾ⥸塼
    58    use basicset,      only : basicset_init
    59  
    60    use axesset,       only : axesset_init
    61  
    62    use constants,     only : constants_init, molwtdry, &
    63      &                       Grav, TempSfc, PressSfc, &
    64      &                       pressbasis, gasrdry, cpdry, cvdry
    65  
    66    !  롼⥸塼
    67    use composition,      only: composition_init, molwtwet, SpcWetMolFr, &
    68      &                       GasNum, CondNum, IdxCC, IdxCG, SpcWetID
    69  
    70    ! ط׻
    71    use ChemCalc, only: ChemCalc_init, xyz_SvapPress
    72  
    73    !  Ŭѥ⥸塼
    74    use setmargin
    75  
    76    use axesset, only:  z_Z,          &!顼ʻǤι
    77      &                 z_dz            !Z γʻֳ
    78  
    79    use namelist_util, only: NmlutilInit, namelist_filename
    80  
    81    use eccm,     only: ECCM_Dry,      &!
    82      &                 ECCM_Wet
    83  
    84    use initialdata_disturb, only: &
    85      &  initialdata_disturb_random,  &
    86      &  initialdata_disturb_gaussXZ, initialdata_disturb_gaussXY, &
    87      &  initialdata_disturb_gaussYZ, initialdata_disturb_gaussXYZ, &
    88      &  initialdata_disturb_dryreg, initialdata_disturb_moist
    89    use initialdata_yamasaki1983, only: initialdata_yamasaki1983_basic
    90    use initialdata_takemi2007, only: initialdata_takemi2007_init, &
    91      &  initialdata_takemi2007_basic, initialdata_takemi2007_wind
    92    use initialdata_toon2002, only: initialdata_toon2002_basic
    93  
    94    !-----    ϥ⥸塼   -----
    95    !  ꥹȥեϥ⥸塼
    96    use RestartFileIO, only : ReStartFileIO_Init, ReStartFileIO_Finalize, rstat
    97    use Arare4FileIO,  only : Arare4FileIO_Init, Arare4FileIO_Var_Get, Arare4FileIO_BZ_Get, &
    98      &                       Arare4FileIO_MMC_Var_Get, Arare4FileIO_MMC_BZ_Get
    99  
   100    !ۤηػ
   101    implicit none
   102  
   103    !ѿ
   104    real(DP), allocatable :: pyz_VelX(:,:,:)
   105    real(DP), allocatable :: xqz_VelY(:,:,:)
   106    real(DP), allocatable :: xyr_VelZ(:,:,:)
   107    real(DP), allocatable :: xyz_Exner(:,:,:)
   108    real(DP), allocatable :: xyz_PTemp(:,:,:)
   109    real(DP), allocatable :: xyz_Km(:,:,:)
   110    real(DP), allocatable :: xyz_Kh(:,:,:)
   111    real(DP), allocatable :: xyz_CDens(:,:,:)
   112    real(DP), allocatable :: xyzf_QMix(:,:,:,:)
   113    real(DP), allocatable :: xyz_DensBZ(:,:,:)
   114    real(DP), allocatable :: xyz_PressBZ(:,:,:)
   115    real(DP), allocatable :: xyz_ExnerBZ(:,:,:)
   116    real(DP), allocatable :: xyz_TempBZ(:,:,:)
   117    real(DP), allocatable :: xyz_PTempBZ(:,:,:)
   118    real(DP), allocatable :: xyz_VelSoundBZ(:,:,:)
   119    real(DP), allocatable :: xyzf_QMixBZ(:,:,:,:)
   120    real(DP), allocatable :: xyz_EffMolWtBZ(:,:,:)
   121    real(DP), allocatable :: z_TempBZ(:)
   122    real(DP), allocatable :: z_PressBZ(:)
   123    real(DP), allocatable :: xyzf_MolFr(:,:,:,:)
   124    real(DP), allocatable :: zf_MolFr(:,:)
   125    real(DP), allocatable :: xyzf_QMixDivMolWt(:,:,:,:)
   126    real(DP), allocatable :: xyzf_HumBZ(:,:,:,:)
   127    real(DP)              :: Time
   128    integer               :: i, j, k, s
   129  
   130    !ѿ
   131    ! Moist 
   132    real(DP)   :: Humidity = 0.0d0 !м
   133    ! Gauss 
   134    real(DP)   :: PTempMax = 0.0d0 !
   135    real(DP)   :: ExnerMax = 0.0d0 !
   136    real(DP)   :: QMixMax = 0.0d0  !
   137    real(DP)   :: Xc = 0.0d0       !濴(X)
   138    real(DP)   :: Yc = 0.0d0       !濴(Y)
   139    real(DP)   :: Zc = 0.0d0       !濴(ľ)
   140    real(DP)   :: Xr = 0.0d0       !Ⱦ(X)
   141    real(DP)   :: Yr = 0.0d0       !Ⱦ(Y)
   142    real(DP)   :: Zr = 0.0d0       !Ⱦ(ľ)
   143    ! Therma-Random 
   144    real(DP)   :: Zpos = 0.0d0     ! Z ɸ [m]
   145    ! Dryreg 
   146    real(DP)   :: XposMin = 0.0d0    ! X ɸ [m]
   147    real(DP)   :: YposMin = 0.0d0    ! Y ɸ [m]
   148    real(DP)   :: ZposMin = 0.0d0    ! Z ɸ [m]
   149    real(DP)   :: XposMax = 0.0d0    ! X ɸ [m]
   150    real(DP)   :: YposMax = 0.0d0    ! Y ɸ [m]
   151    real(DP)   :: ZposMax = 0.0d0    ! Z ɸ [m]
   152  
   153    real(DP)   :: TempTr = 100.0d0     !ή̤β [k]
   154    real(DP)   :: Dhight = 10.0d3       !ŤߴؿΥѥ᡼ [m]
   155  
   156    integer               :: IDBasic                = 0
   157    integer, parameter    :: IDBasicArare4          = 1
   158    integer, parameter    :: IDBasicArare4mmc       = 2
   159    integer, parameter    :: IDBasicYamasaki1983    = 3
   160    integer, parameter    :: IDBasicTakemi2007      = 4
   161    integer, parameter    :: IDBasicIsoThermal      = 5
   162    integer, parameter    :: IDBasicDry             = 6
   163    integer, parameter    :: IDBasicMoist           = 7
   164    integer, parameter    :: IDBasicToon2002        = 8
   165    integer               :: IDDisturbPTemp         = 0
   166    integer, parameter    :: IDDisturbPTempGaussXY  = 1
   167    integer, parameter    :: IDDisturbPTempGaussXZ  = 2
   168    integer, parameter    :: IDDisturbPTempGaussYZ  = 3
   169    integer, parameter    :: IDDisturbPTempGaussXYZ = 4
   170    integer, parameter    :: IDDisturbPTempRandom   = 5
   171    integer               :: IDDisturbExner         = 0
   172    integer, parameter    :: IDDisturbExnerGaussXY  = 1
   173    integer, parameter    :: IDDisturbExnerGaussXZ  = 2
   174    integer, parameter    :: IDDisturbExnerGaussYZ  = 3
   175    integer, parameter    :: IDDisturbExnerGaussXYZ = 4
   176    integer               :: IDDisturbQMix          = 0
   177    integer, parameter    :: IDDisturbQMixGaussXY   = 1
   178    integer, parameter    :: IDDisturbQMixGaussXZ   = 2
   179    integer, parameter    :: IDDisturbQMixGaussYZ   = 3
   180    integer, parameter    :: IDDisturbQMixGaussXYZ  = 4
   181    integer, parameter    :: IDDisturbQMixDryreg    = 5
   182    integer, parameter    :: IDDisturbQMixMoist     = 6
   183    integer               :: IDDisturbWind          = 0
   184    integer, parameter    :: IDDisturbWindTakemi2007= 1
   185    integer               :: IDDisturb              = 0
   186    integer, parameter    :: IDDisturbArare4        = 1
   187    integer, parameter    :: IDDisturbArare4mmc     = 2
   188  
   189  
   190    !------------------------------------------
   191    ! ³ ; Initialize procedure
   192    !
   193    call MainInit
   194  
   195    Time = 0.0d0
   196    call MessageNotify( "M", "main", "Making Initial data...." )
   197  
   198    !---------------------------------------------------------------
   199    ! ܾ.
   200    !
   201    select case(IDBasic)
   202  
   203    case (IDBasicArare4)
   204      ! deepconv/arare4 Υҥȥ꡼ե뤫ͤɤ߹
   205      !
   206      call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   207      call Arare4fileio_BZ_Get( &
   208        & xyz_PressBZ,   & ! (out)
   209        & xyz_ExnerBZ,   & ! (out)
   210        & xyz_TempBZ,    & ! (out)
   211        & xyz_PTempBZ,   & ! (out)
   212        & xyz_DensBZ,    & ! (out)
   213        & xyz_VelSoundBZ,& ! (out)
   214        & xyzf_QMixBZ,   & ! (out)
   215        & xyz_EffMolWtBZ & ! (out)
   216        & )
   217  
   218    case (IDBasicArare4mmc)
   219      ! deepconv/arare4 ǤΥҥȥ꡼ե뤫ͤɤ߹
   220      !
   221      call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   222  
   223      call Arare4fileio_MMC_BZ_Get( &
   224        & xyz_PressBZ,   & ! (out)
   225        & xyz_ExnerBZ,   & ! (out)
   226        & xyz_TempBZ,    & ! (out)
   227        & xyz_PTempBZ,   & ! (out)
   228        & xyz_DensBZ,    & ! (out)
   229        & xyz_VelSoundBZ,& ! (out)
   230        & xyzf_QMixBZ,   & ! (out)
   231        & xyz_EffMolWtBZ & ! (out)
   232        & )
   233  
   234    case(IDBasicIsoThermal)
   235      ! /Ϲθʤ
   236      !
   237      call MessageNotify( "M", "main", "Making Initial data (basic) named IsoThermal..." )
   238  
   239      z_TempBZ = TempSfc
   240      z_PressBZ = PressSfc
   241      zf_MolFr = 0.0d0
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t773 = 1, (zf_molfr.DSC.U2 - zf_molfr.DSC.L2 + 1)*(            
     .       1   zf_molfr.DSC.U1 - zf_molfr.DSC.L1 + 1)                         
     .           zf_molfr(zf_molfr.DSC.L1+t773-1,zf_molfr.DSC.L2) =             
     .       1      0.0000000000000000e+000                                     
     .        end do                                                            
   242  
   243      ! Ĥδܾͤ
   244      call DetermineBZ
   245  
   246    case(IDBasicDry)
   247      ! ǮŪʽ
   248      !
   249      call MessageNotify( "M", "main", "Making Initial data (basic) named DRY..." )
   250      call eccm_dry( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, zf_MolFr )
   251      if (minval(z_TempBZ(1:nz)) < TempTr) then
   252        call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   253      end if
   254  
   255      ! Ĥδܾͤ
   256      call DetermineBZ
   257  
   258  ! ǥХåѤǤʤ
   259  !
   260  !  case(IDBasicMoist)
   261  !    ! ǮŪʽ
   262  !    !
   263  !    call MessageNotify( "M", "main", "Making Initial data (basic) named MOIST..." )
   264  !    call eccm_wet( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, zf_MolFr )
   265  !    call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   266  !
   267  !    ! Ĥδܾͤ
   268  !    call DetermineBZ
   269  
   270    case(IDBasicToon2002)
   271      ! 
   272      !
   273      call MessageNotify( "M", "main", "Making Initial data (basic) named Toon et al. 2002..." )
   274      call initialdata_toon2002_basic( z_TempBZ, z_PressBZ ) !(out)
   275  !    call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   276  
   277      ! Ĥδܾͤ
   278      call DetermineBZ
   279  
   280    case(IDBasicTakemi2007)
   281      ! Takemi(2007)δܾѤ
   282      !
   283      call MessageNotify( "M", "main", "Making Initial data named Takemi2007..." )
   284      call initialdata_takemi2007_basic( z_TempBZ, z_PressBZ, zf_MolFr )
   285  
   286      ! Ĥδܾͤ
   287      call DetermineBZ
   288  
   289    case(IDBasicYamasaki1983)
   290      ! Yamasaki(1983)β٤м٤δ¬ͤѤ
   291      !
   292      call MessageNotify( "M", "main", "Making Initial data named Yamasaki1983..." )
   293      call initialdata_yamasaki1983_basic( z_TempBZ, z_PressBZ, zf_MolFr )
   294  
   295      ! Ĥδܾͤ
   296      call DetermineBZ
   297  
   298    end select
   299  
   300    !---------------------------------------------------------
   301    ! ͤ
   302    !
   303  
   304    ! : ͤ
   305    !
   306    select case(IDDisturbPTemp)
   307  
   308    case(IDDisturbPTempGaussXY)
   309      ! : ʬۤͿ (XY)
   310      !
   311      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   312      call initialdata_disturb_gaussXY(PTempMax, Xc, Xr, Yc, Yr, xyz_PTemp)
   313      call SetMargin_xyz( xyz_PTemp )
   314  
   315    case(IDDisturbPTempGaussXZ)
   316      ! : ʬۤͿ (XZ)
   317      !
   318      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   319      call initialdata_disturb_gaussXZ(PTempMax, Xc, Xr, Zc, Zr, xyz_PTemp)
   320      call SetMargin_xyz( xyz_PTemp )
   321  
   322    case(IDDisturbPTempGaussYZ)
   323      ! : ʬۤͿ (YZ)
   324      !
   325      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   326      call initialdata_disturb_gaussYZ(PTempMax, Yc, Yr, Zc, Zr, xyz_PTemp)
   327      call SetMargin_xyz( xyz_PTemp )
   328  
   329    case(IDDisturbPTempGaussXYZ)
   330      ! : ʬۤͿ (XYZ)
   331      !
   332      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   333      call initialdata_disturb_gaussXYZ(PTempMax, Xc, Xr, Yc, Yr, Zc, Zr, xyz_PTemp)
   334      call SetMargin_xyz( xyz_PTemp )
   335  
   336    case(IDDisturbPTempRandom)
   337      ! : ꤵ줿٤˥ʬۤͿ.
   338      !
   339      call MessageNotify( "M", "main", "Making Initial data (disturb) named random..." )
   340      call initialdata_disturb_random(PTempMax, Zpos, xyz_PTemp)
   341      call SetMargin_xyz( xyz_PTemp )
   342  
   343    end select
   344  
   345  
   346    ! ʡؿ: ͤ
   347    !
   348    select case(IDDisturbExner)
   349  
   350    case(IDDisturbExnerGaussXY)
   351      ! ʡؿ: ʬۤͿ (XY)
   352      !
   353      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   354      call initialdata_disturb_gaussXY(ExnerMax, Xc, Xr, Yc, Yr, xyz_Exner)
   355      call SetMargin_xyz( xyz_Exner )
   356  
   357    case(IDDisturbExnerGaussXZ)
   358      ! ʡؿ: ʬۤͿ (XZ)
   359      !
   360      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   361      call initialdata_disturb_gaussXZ(ExnerMax, Xc, Xr, Zc, Zr, xyz_Exner)
   362      call SetMargin_xyz( xyz_Exner )
   363  
   364    case(IDDisturbExnerGaussYZ)
   365      ! ʡؿ: ʬۤͿ (YZ)
   366      !
   367      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   368      call initialdata_disturb_gaussYZ(ExnerMax, Yc, Yr, Zc, Zr, xyz_Exner)
   369      call SetMargin_xyz( xyz_Exner )
   370  
   371    case(IDDisturbExnerGaussXYZ)
   372      ! ʡؿ: ʬۤͿ (XYZ)
   373      !
   374      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   375      call initialdata_disturb_gaussXYZ(ExnerMax, Xc, Xr, Yc, Yr, Zc, Zr, xyz_Exner)
   376      call SetMargin_xyz( xyz_Exner )
   377  
   378    end select
   379  
   380  
   381    ! : ͤ
   382    !
   383    select case(IDDisturbQMix)
   384  
   385    case(IDDisturbQMixGaussXY)
   386      ! : ʬۤͿ (XY)
   387      !
   388      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   389      call initialdata_disturb_gaussXY(QMixMax, Xc, Xr, Yc, Yr, xyzf_QMix(:,:,:,1))
   390      call SetMargin_xyzf( xyzf_QMix )
   391  
   392    case(IDDisturbQMixGaussXZ)
   393      ! : ʬۤͿ (XZ)
   394      !
   395      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   396      call initialdata_disturb_gaussXZ(QMixMax, Xc, Xr, Zc, Zr, xyzf_QMix(:,:,:,1))
   397      call SetMargin_xyzf( xyzf_QMix )
   398  
   399    case(IDDisturbQMixGaussYZ)
   400      ! : ʬۤͿ (YZ)
   401      !
   402      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   403      call initialdata_disturb_gaussYZ(QMixMax, Yc, Yr, Zc, Zr, xyzf_QMix(:,:,:,1))
   404      call SetMargin_xyzf( xyzf_QMix )
   405  
   406    case(IDDisturbQMixGaussXYZ)
   407      ! : ʬۤͿ (XYZ)
   408      !
   409      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   410      call initialdata_disturb_gaussXYZ(QMixMax, Xc, Xr, Yc, Yr, Zc, Zr, xyzf_QMix(:,:,:,1))
   411      call SetMargin_xyzf( xyzf_QMix )
   412  
   413    case(IDDisturbQMixDryreg)
   414      ! : ΰ
   415      !
   416      call MessageNotify( "M", "main", "Making Initial data (disturb) named Dryreg..." )
   417      call initialdata_disturb_dryreg(  &
   418        & XposMin, XposMax, YposMin, YposMax, ZposMin, ZposMax, xyzf_QMix)
   419      call SetMargin_xyzf( xyzf_QMix )
   420  
   421    case(IDDisturbQMixMoist)
   422      ! : ǮŪʬۤͿ
   423      !
   424      call MessageNotify( "M", "main", "Making Initial data (disturb) named MOIST..." )
   425      call initialdata_disturb_moist(Humidity, xyzf_QMix)
   426      call SetMargin_xyzf( xyzf_QMix )
   427  
   428    end select
   429  
   430    ! : ®پͤ
   431    !
   432    select case(IDDisturbWind)
   433    case (IDDisturbWindTakemi2007)
   434      ! Takemi (2007) ®ʬ
   435      !
   436      call MessageNotify( "M", "main", "Making Initial data (disturb) named Wind takemi2007..." )
   437      call initialdata_takemi2007_wind( pyz_VelX )
   438      call SetMargin_pyz( pyz_VelX )
   439  
   440    end select
   441  
   442    ! 礷ƾͿ
   443    !
   444    select case(IDDisturb)
   445    case (IDDisturbArare4)
   446      call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   447      call Arare4fileio_Var_Get( &
   448        & pyz_VelX,     & ! (out)
   449        & xqz_VelY,     & ! (out)
   450        & xyr_VelZ,     & ! (out)
   451        & xyz_PTemp,    & ! (out)
   452        & xyz_Exner,    & ! (out)
   453        & xyzf_QMix,    & ! (out)
   454        & xyz_Km,       & ! (out)
   455        & xyz_Kh,       & ! (out)
   456        & xyz_CDens   )   ! (out)
   457  
   458    case (IDDisturbArare4mmc)
   459      call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   460      call Arare4fileio_MMC_Var_Get( &
   461        & pyz_VelX,     & ! (out)
   462        & xqz_VelY,     & ! (out)
   463        & xyr_VelZ,     & ! (out)
   464        & xyz_PTemp,    & ! (out)
   465        & xyz_Exner,    & ! (out)
   466        & xyzf_QMix,    & ! (out)
   467        & xyz_Km,       & ! (out)
   468        & xyz_Kh,       & ! (out)
   469        & xyz_CDens   )   ! (out)
   470    end select
   471  
   472    !------------------------------------------------
   473    ! ե
   474    !
   475    call MessageNotify( "M", "main", "Output variables into netCDF file..." )
   476  
   477    ! ꥹȥե. ܾȾ.
   478    !
   479    call ReStartFileIO_Init
   480  
   481    call HistoryPut( 't',     Time,      rstat)
   482    call HistoryPut( 'VelX',  pyz_VelX,  rstat)
   483    call HistoryPut( 'VelY',  xqz_VelY,  rstat)
   484    call HistoryPut( 'VelZ',  xyr_VelZ,  rstat)
   485    call HistoryPut( 'Exner', xyz_Exner, rstat)
   486    call HistoryPut( 'PTemp', xyz_PTemp, rstat)
   487    call HistoryPut( 'Km',    xyz_Km,    rstat)
   488    call HistoryPut( 'Kh',    xyz_Kh,    rstat)
   489    call HistoryPut( 'QMix',  xyzf_QMix, rstat)
   490    call HistoryPut( 'CDens', xyz_CDens, rstat)
   491  
   492    ! ܾΥե
   493    !
   494    call HistoryPut( 'DensBZ',     xyz_DensBZ    , rstat)
   495    call HistoryPut( 'ExnerBZ',    xyz_ExnerBZ   , rstat)
   496    call HistoryPut( 'PTempBZ',    xyz_PTempBZ   , rstat)
   497    call HistoryPut( 'VelSoundBZ', xyz_VelSoundBZ, rstat)
   498    call HistoryPut( 'TempBZ',     xyz_TempBZ    , rstat)
   499    call HistoryPut( 'PressBZ',    xyz_PressBZ   , rstat)
   500    call HistoryPut( 'QMixBZ',     xyzf_QMixBZ   , rstat)
   501    call HistoryPut( 'EffMolWtBZ', xyz_EffMolWtBZ, rstat)
   502    call HistoryPut( 'HumBZ',      xyzf_HumBZ    , rstat)
   503  
   504    call ReStartFileIO_Finalize
   505  
   506    !----------------------------------------------------
   507    ! MPI END
   508    !
   509    call MPIWrapperFinalize
   510  
   511  contains
   512  
   513    subroutine ArareAlloc
   514      !
   515      !Ȥ, , ͤȤƥ.
   516      !
   517  
   518      !ۤηػ
   519      implicit none
   520  
   521      !
   522      allocate( pyz_VelX(imin:imax, jmin:jmax, kmin:kmax) )
   523      allocate( xqz_VelY(imin:imax, jmin:jmax, kmin:kmax) )
   524      allocate( xyr_VelZ(imin:imax, jmin:jmax, kmin:kmax) )
   525      allocate( xyz_Exner(imin:imax, jmin:jmax, kmin:kmax) )
   526      allocate( xyz_PTemp(imin:imax, jmin:jmax, kmin:kmax) )
   527      allocate( xyz_Km(imin:imax, jmin:jmax, kmin:kmax) )
   528      allocate( xyz_Kh(imin:imax, jmin:jmax, kmin:kmax) )
   529      allocate( xyz_CDens(imin:imax, jmin:jmax, kmin:kmax) )
   530      allocate( xyzf_QMix(imin:imax, jmin:jmax, kmin:kmax, ncmax) )
   531  
   532      allocate( xyz_DensBZ(imin:imax,jmin:jmax,kmin:kmax))
   533      allocate( xyz_PressBZ(imin:imax,jmin:jmax,kmin:kmax))
   534      allocate( xyz_ExnerBZ(imin:imax,jmin:jmax,kmin:kmax))
   535      allocate( xyz_TempBZ(imin:imax,jmin:jmax,kmin:kmax))
   536      allocate( xyz_PTempBZ(imin:imax,jmin:jmax,kmin:kmax))
   537      allocate( xyz_VelSoundBZ(imin:imax,jmin:jmax,kmin:kmax))
   538      allocate( xyzf_QMixBZ(imin:imax,jmin:jmax,kmin:kmax,ncmax))
   539      allocate( xyz_EffMolWtBZ(imin:imax,jmin:jmax,kmin:kmax))
   540      allocate( z_TempBZ(kmin:kmax))
   541      allocate( z_PressBZ(kmin:kmax))
   542      allocate( xyzf_MolFr(imin:imax, jmin:jmax, kmin:kmax, ncmax))
   543      allocate( zf_MolFr(kmin:kmax, ncmax))
   544      allocate( xyzf_QMixDivMolWt(imin:imax,jmin:jmax,kmin:kmax, ncmax))
   545      allocate( xyzf_HumBZ(imin:imax,jmin:jmax,kmin:kmax, ncmax))
   546  
   547      pyz_VelX = 0.0d0
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t616 = 1, (pyz_velx.DSC.U3 - pyz_velx.DSC.L3 + 1)*(            
     .       1   pyz_velx.DSC.U2 - pyz_velx.DSC.L2 + 1)*(pyz_velx.DSC.U1 -      
     .       2   pyz_velx.DSC.L1 + 1)                                           
     .           pyz_velx(pyz_velx.DSC.L1+t616-1,pyz_velx.DSC.L2,pyz_velx.DSC.L3
     .       1      ) = 0.0000000000000000e+000                                 
     .        end do                                                            
   548      xqz_VelY = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t625 = 1, (xqz_vely.DSC.U3 - xqz_vely.DSC.L3 + 1)*(            
     .       1   xqz_vely.DSC.U2 - xqz_vely.DSC.L2 + 1)*(xqz_vely.DSC.U1 -      
     .       2   xqz_vely.DSC.L1 + 1)                                           
     .           xqz_vely(xqz_vely.DSC.L1+t625-1,xqz_vely.DSC.L2,xqz_vely.DSC.L3
     .       1      ) = 0.0000000000000000e+000                                 
     .        end do                                                            
   549      xyr_VelZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t634 = 1, (xyr_velz.DSC.U3 - xyr_velz.DSC.L3 + 1)*(            
     .       1   xyr_velz.DSC.U2 - xyr_velz.DSC.L2 + 1)*(xyr_velz.DSC.U1 -      
     .       2   xyr_velz.DSC.L1 + 1)                                           
     .           xyr_velz(xyr_velz.DSC.L1+t634-1,xyr_velz.DSC.L2,xyr_velz.DSC.L3
     .       1      ) = 0.0000000000000000e+000                                 
     .        end do                                                            
   550      xyz_PTemp = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t643 = 1, (xyz_ptemp.DSC.U3 - xyz_ptemp.DSC.L3 + 1)*(          
     .       1   xyz_ptemp.DSC.U2 - xyz_ptemp.DSC.L2 + 1)*(xyz_ptemp.DSC.U1 -   
     .       2   xyz_ptemp.DSC.L1 + 1)                                          
     .           xyz_ptemp(xyz_ptemp.DSC.L1+t643-1,xyz_ptemp.DSC.L2,            
     .       1      xyz_ptemp.DSC.L3) = 0.0000000000000000e+000                 
     .        end do                                                            
   551      xyz_Exner = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t652 = 1, (xyz_exner.DSC.U3 - xyz_exner.DSC.L3 + 1)*(          
     .       1   xyz_exner.DSC.U2 - xyz_exner.DSC.L2 + 1)*(xyz_exner.DSC.U1 -   
     .       2   xyz_exner.DSC.L1 + 1)                                          
     .           xyz_exner(xyz_exner.DSC.L1+t652-1,xyz_exner.DSC.L2,            
     .       1      xyz_exner.DSC.L3) = 0.0000000000000000e+000                 
     .        end do                                                            
   552      xyz_Km = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t661 = 1, (xyz_km.DSC.U3 - xyz_km.DSC.L3 + 1)*(xyz_km.DSC.U2 - 
     .       1   xyz_km.DSC.L2 + 1)*(xyz_km.DSC.U1 - xyz_km.DSC.L1 + 1)         
     .           xyz_km(xyz_km.DSC.L1+t661-1,xyz_km.DSC.L2,xyz_km.DSC.L3) =     
     .       1      0.0000000000000000e+000                                     
     .        end do                                                            
   553      xyz_Kh = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t670 = 1, (xyz_kh.DSC.U3 - xyz_kh.DSC.L3 + 1)*(xyz_kh.DSC.U2 - 
     .       1   xyz_kh.DSC.L2 + 1)*(xyz_kh.DSC.U1 - xyz_kh.DSC.L1 + 1)         
     .           xyz_kh(xyz_kh.DSC.L1+t670-1,xyz_kh.DSC.L2,xyz_kh.DSC.L3) =     
     .       1      0.0000000000000000e+000                                     
     .        end do                                                            
   554      xyz_CDens = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t679 = 1, (xyz_cdens.DSC.U3 - xyz_cdens.DSC.L3 + 1)*(          
     .       1   xyz_cdens.DSC.U2 - xyz_cdens.DSC.L2 + 1)*(xyz_cdens.DSC.U1 -   
     .       2   xyz_cdens.DSC.L1 + 1)                                          
     .           xyz_cdens(xyz_cdens.DSC.L1+t679-1,xyz_cdens.DSC.L2,            
     .       1      xyz_cdens.DSC.L3) = 0.0000000000000000e+000                 
     .        end do                                                            
   555      xyzf_QMix = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t688 = 1, (xyzf_qmix.DSC.U4 - xyzf_qmix.DSC.L4 + 1)*(          
     .       1   xyzf_qmix.DSC.U3 - xyzf_qmix.DSC.L3 + 1)*(xyzf_qmix.DSC.U2 -   
     .       2   xyzf_qmix.DSC.L2 + 1)*(xyzf_qmix.DSC.U1 - xyzf_qmix.DSC.L1 + 1)
     .           xyzf_qmix(xyzf_qmix.DSC.L1+t688-1,xyzf_qmix.DSC.L2,            
     .       1      xyzf_qmix.DSC.L3,xyzf_qmix.DSC.L4) = 0.0000000000000000e+000
     .        end do                                                            
   556  
   557      xyz_DensBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t700 = 1, (xyz_densbz.DSC.U3 - xyz_densbz.DSC.L3 + 1)*(        
     .       1   xyz_densbz.DSC.U2 - xyz_densbz.DSC.L2 + 1)*(xyz_densbz.DSC.U1  
     .       2    - xyz_densbz.DSC.L1 + 1)                                      
     .           xyz_densbz(xyz_densbz.DSC.L1+t700-1,xyz_densbz.DSC.L2,         
     .       1      xyz_densbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   558      xyz_PressBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t709 = 1, (xyz_pressbz.DSC.U3 - xyz_pressbz.DSC.L3 + 1)*(      
     .       1   xyz_pressbz.DSC.U2 - xyz_pressbz.DSC.L2 + 1)*(                 
     .       2   xyz_pressbz.DSC.U1 - xyz_pressbz.DSC.L1 + 1)                   
     .           xyz_pressbz(xyz_pressbz.DSC.L1+t709-1,xyz_pressbz.DSC.L2,      
     .       1      xyz_pressbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   559      xyz_ExnerBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t718 = 1, (xyz_exnerbz.DSC.U3 - xyz_exnerbz.DSC.L3 + 1)*(      
     .       1   xyz_exnerbz.DSC.U2 - xyz_exnerbz.DSC.L2 + 1)*(                 
     .       2   xyz_exnerbz.DSC.U1 - xyz_exnerbz.DSC.L1 + 1)                   
     .           xyz_exnerbz(xyz_exnerbz.DSC.L1+t718-1,xyz_exnerbz.DSC.L2,      
     .       1      xyz_exnerbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   560      xyz_TempBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t727 = 1, (xyz_tempbz.DSC.U3 - xyz_tempbz.DSC.L3 + 1)*(        
     .       1   xyz_tempbz.DSC.U2 - xyz_tempbz.DSC.L2 + 1)*(xyz_tempbz.DSC.U1  
     .       2    - xyz_tempbz.DSC.L1 + 1)                                      
     .           xyz_tempbz(xyz_tempbz.DSC.L1+t727-1,xyz_tempbz.DSC.L2,         
     .       1      xyz_tempbz.DSC.L3) = 0.0000000000000000e+000                
     .        end do                                                            
   561      xyz_PTempBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t736 = 1, (xyz_ptempbz.DSC.U3 - xyz_ptempbz.DSC.L3 + 1)*(      
     .       1   xyz_ptempbz.DSC.U2 - xyz_ptempbz.DSC.L2 + 1)*(                 
     .       2   xyz_ptempbz.DSC.U1 - xyz_ptempbz.DSC.L1 + 1)                   
     .           xyz_ptempbz(xyz_ptempbz.DSC.L1+t736-1,xyz_ptempbz.DSC.L2,      
     .       1      xyz_ptempbz.DSC.L3) = 0.0000000000000000e+000               
     .        end do                                                            
   562      xyz_VelSoundBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t745 = 1, (xyz_velsoundbz.DSC.U3 - xyz_velsoundbz.DSC.L3 + 1)*(
     .       1   xyz_velsoundbz.DSC.U2 - xyz_velsoundbz.DSC.L2 + 1)*(           
     .       2   xyz_velsoundbz.DSC.U1 - xyz_velsoundbz.DSC.L1 + 1)             
     .           xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t745-1,                   
     .       1      xyz_velsoundbz.DSC.L2,xyz_velsoundbz.DSC.L3) =              
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   563      xyzf_QMixBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t754 = 1, (xyzf_qmixbz.DSC.U4 - xyzf_qmixbz.DSC.L4 + 1)*(      
     .       1   xyzf_qmixbz.DSC.U3 - xyzf_qmixbz.DSC.L3 + 1)*(                 
     .       2   xyzf_qmixbz.DSC.U2 - xyzf_qmixbz.DSC.L2 + 1)*(                 
     .       3   xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1 + 1)                   
     .           xyzf_qmixbz(xyzf_qmixbz.DSC.L1+t754-1,xyzf_qmixbz.DSC.L2,      
     .       1      xyzf_qmixbz.DSC.L3,xyzf_qmixbz.DSC.L4) =                    
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   564      xyz_EffMolWtBZ  = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t766 = 1, (xyz_effmolwtbz.DSC.U3 - xyz_effmolwtbz.DSC.L3 + 1)*(
     .       1   xyz_effmolwtbz.DSC.U2 - xyz_effmolwtbz.DSC.L2 + 1)*(           
     .       2   xyz_effmolwtbz.DSC.U1 - xyz_effmolwtbz.DSC.L1 + 1)             
     .           xyz_effmolwtbz(xyz_effmolwtbz.DSC.L1+t766-1,                   
     .       1      xyz_effmolwtbz.DSC.L2,xyz_effmolwtbz.DSC.L3) =              
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   565      z_TempBZ  = 0.0d0
   566      z_PressBZ = 0.0d0
   567      xyzf_MolFr = 0.0d0
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t781 = 1, (xyzf_molfr.DSC.U4 - xyzf_molfr.DSC.L4 + 1)*(        
     .       1   xyzf_molfr.DSC.U3 - xyzf_molfr.DSC.L3 + 1)*(xyzf_molfr.DSC.U2  
     .       2    - xyzf_molfr.DSC.L2 + 1)*(xyzf_molfr.DSC.U1 -                 
     .       3   xyzf_molfr.DSC.L1 + 1)                                         
     .           xyzf_molfr(xyzf_molfr.DSC.L1+t781-1,xyzf_molfr.DSC.L2,         
     .       1      xyzf_molfr.DSC.L3,xyzf_molfr.DSC.L4) =                      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   568      zf_MolFr = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t793 = 1, (zf_molfr.DSC.U2 - zf_molfr.DSC.L2 + 1)*(            
     .       1   zf_molfr.DSC.U1 - zf_molfr.DSC.L1 + 1)                         
     .           zf_molfr(zf_molfr.DSC.L1+t793-1,zf_molfr.DSC.L2) =             
     .       1      0.0000000000000000e+000                                     
     .        end do                                                            
   569      xyzf_QMixDivMolWt = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t799 = 1, (xyzf_qmixdivmolwt.DSC.U4 - xyzf_qmixdivmolwt.DSC.L4 
     .       1    + 1)*(xyzf_qmixdivmolwt.DSC.U3 - xyzf_qmixdivmolwt.DSC.L3 + 1)
     .       2   *(xyzf_qmixdivmolwt.DSC.U2 - xyzf_qmixdivmolwt.DSC.L2 + 1)*(   
     .       3   xyzf_qmixdivmolwt.DSC.U1 - xyzf_qmixdivmolwt.DSC.L1 + 1)       
     .           xyzf_qmixdivmolwt(xyzf_qmixdivmolwt.DSC.L1+t799-1,             
     .       1      xyzf_qmixdivmolwt.DSC.L2,xyzf_qmixdivmolwt.DSC.L3,          
     .       2      xyzf_qmixdivmolwt.DSC.L4) = 0.0000000000000000e+000         
     .        end do                                                            
   570      xyzf_HumBZ = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t811 = 1, (xyzf_humbz.DSC.U4 - xyzf_humbz.DSC.L4 + 1)*(        
     .       1   xyzf_humbz.DSC.U3 - xyzf_humbz.DSC.L3 + 1)*(xyzf_humbz.DSC.U2  
     .       2    - xyzf_humbz.DSC.L2 + 1)*(xyzf_humbz.DSC.U1 -                 
     .       3   xyzf_humbz.DSC.L1 + 1)                                         
     .           xyzf_humbz(xyzf_humbz.DSC.L1+t811-1,xyzf_humbz.DSC.L2,         
     .       1      xyzf_humbz.DSC.L3,xyzf_humbz.DSC.L4) =                      
     .       2      0.0000000000000000e+000                                     
     .        end do                                                            
   571  
   572    end subroutine ArareAlloc
   573  
   574  
   575    subroutine DetermineBZ
   576  
   577      !---------------------------------------------------------------
   578      ! ١
   579      !
   580  
   581      ! 3 ˳Ǽ
   582      do k = 1, nz
   583        do j = 1, ny
   584          do i = 1, nx
   585            xyz_TempBZ(i,j,k)  = z_TempBZ(k)
   586            xyz_PressBZ(i,j,k) = z_PressBZ(k)
   587          end do
     .        i = 1                                                             
     .        if (nx .gt. 0) then                                               
     .  !CDIR    NODEP                                                          
     .           do i = 1, nx                                                   
     .              xyz_tempbz(i,j,k) = z_tempbz(k)                             
     .              xyz_pressbz(i,j,k) = z_pressbz(k)                           
     .           end do                                                         
     .           i = nx + 1                                                     
     .        endif                                                             
   588        end do
   589      end do
   590  
   591      !Τͤ
   592      !
   593      call SetMargin_xyz( xyz_TempBZ )
   594      call SetMargin_xyz( xyz_PressBZ)
   595  
   596      !---------------------------------------------------------------
   597      ! 
   598      !
   599      !ʿˤϰ
   600      do k = 1, nz
   601        do j = 1, ny
   602          do i = 1, nx
   603            xyzf_MolFr(i,j,k,:) = zf_MolFr(k,:)
   604          end do
     .        i = 1                                                             
     .        if (nx .gt. 0) then                                               
     .  !CDIR    NODEP                                                          
     .           do t605 = 1, xyzf_molfr.DSC.U4 - xyzf_molfr.DSC.L4 + 1         
     .              do i = 1, nx                                                
     .                 xyzf_molfr(i,j,k,t605-1+xyzf_molfr.DSC.L4) = zf_molfr(k, 
     .       1            t605-1+zf_molfr.DSC.L2)                               
     .              end do                                                      
     .           end do                                                         
     .           i = nx + 1                                                     
     .        endif                                                             
   605        end do
   606      end do
   607  
   608      !Τͤ
   609      !
   610      call SetMargin_xyzf( xyzf_MolFr )
   611  
   612      !Υ򺮹Ѵ
   613      do s = 1, ncmax
   614        xyzf_QMixBZ(:,:,:,s) = xyzf_MolFr(:,:,:,s) * MolWtWet(s) / MolWtDry
     .        if (xyzf_molfr.DSC.U2 - t86 + 1 .gt. 0) then                      
     .           J1 = and(xyzf_molfr.DSC.U2 - t86 + 1,3)                        
     .  !CDIR    NODEP                                                          
     .           do t611 = 1, J1                                                
     .              D2 = molwtwet(s)/molwtdry                                   
     .  !CDIR       NODEP                                                       
     .              do t613 = 1, xyzf_molfr.DSC.U1 - t84 + 1                    
     .                 xyzf_qmixbz(t104+t613-1,t611-1+t106,t609+t108,s) =       
     .       1            xyzf_molfr(t84+t613-1,t611-1+t86,t609+t88,s)*D2       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t611 = J1 + 1, xyzf_molfr.DSC.U2 - t86 + 1, 4               
     .              D1 = molwtwet(s)                                            
     .              D6 = D1/molwtdry                                            
     .              D5 = D1/molwtdry                                            
     .              D4 = D1/molwtdry                                            
     .              D3 = D1/molwtdry                                            
     .  !CDIR       NODEP                                                       
     .              do t613 = 1, xyzf_molfr.DSC.U1 - t84 + 1                    
     .                 xyzf_qmixbz(t104+t613-1,t611-1+t106,t609+t108,s) =       
     .       1            xyzf_molfr(t84+t613-1,t611-1+t86,t609+t88,s)*D3       
     .                 xyzf_qmixbz(t104+t613-1,t611+t106,t609+t108,s) =         
     .       1            xyzf_molfr(t84+t613-1,t611+t86,t609+t88,s)*D4         
     .                 xyzf_qmixbz(t104+t613-1,t611+1+t106,t609+t108,s) =       
     .       1            xyzf_molfr(t84+t613-1,t611+1+t86,t609+t88,s)*D5       
     .                 xyzf_qmixbz(t104+t613-1,t611+2+t106,t609+t108,s) =       
     .       1            xyzf_molfr(t84+t613-1,t611+2+t86,t609+t88,s)*D6       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   615      end do
   616  
   617      !  !ͤʤꤹʤ褦˺ͤͿ
   618      !  where (xyzf_QMixBZ <= 1.0d-20 )
   619      !    xyzf_QMixBZ = 1.0d-20
   620      !  end where
   621  
   622      !Τͤ
   623      !
   624      call SetMargin_xyzf( xyzf_QMixBZ )
   625  
   626      !---------------------------------------------------------------
   627      ! ʬ̤θ
   628      !
   629      do s = 1, ncmax
   630        xyzf_QMixDivMolWt(:,:,:,s) = xyzf_QMixBZ(:,:,:,s) / MolWtWet(s)
     .        if (t105 - t106 + 1 .gt. 0) then                                  
     .           J2 = and(t105 - t106 + 1,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t623 = 1, J2                                                
     .              D8 = 1.D0/molwtwet(s)                                       
     .  !CDIR       NODEP                                                       
     .              do t625 = 1, t103 - t104 + 1                                
     .                 xyzf_qmixdivmolwt(t118+t625-1,t623-1+t120,t621+t122,s) = 
     .       1            xyzf_qmixbz(t104+t625-1,t623-1+t106,t621+t108,s)*D8   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t623 = J2 + 1, t105 - t106 + 1, 4                           
     .              D7 = molwtwet(s)                                            
     .  !CDIR       NODEP                                                       
     .              do t625 = 1, t103 - t104 + 1                                
     .                 xyzf_qmixdivmolwt(t118+t625-1,t623-1+t120,t621+t122,s) = 
     .       1            xyzf_qmixbz(t104+t625-1,t623-1+t106,t621+t108,s)/D7   
     .                 xyzf_qmixdivmolwt(t118+t625-1,t623+t120,t621+t122,s) =   
     .       1            xyzf_qmixbz(t104+t625-1,t623+t106,t621+t108,s)/D7     
     .                 xyzf_qmixdivmolwt(t118+t625-1,t623+1+t120,t621+t122,s) = 
     .       1            xyzf_qmixbz(t104+t625-1,t623+1+t106,t621+t108,s)/D7   
     .                 xyzf_qmixdivmolwt(t118+t625-1,t623+2+t120,t621+t122,s) = 
     .       1            xyzf_qmixbz(t104+t625-1,t623+2+t106,t621+t108,s)/D7   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   631      end do
   632  
   633      xyz_EffMolWtBZ = &
     .  !CDIR NODEP                                                             
     .        do J9 = 0, xyzf_qmixbz.DSC.U1 - xyzf_qmixbz.DSC.L1, 9993          
     .           J10=min0(xyzf_qmixbz.DSC.U1+1-xyzf_qmixbz.DSC.L1-J9,9993)      
     .  !CDIR    NODEP                                                          
     .           do t374 = 1, J10                                               
     .              D9(t374) = 0.0000000000000000e+000                          
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t377 = 1, xyzf_qmixbz.DSC.U4 - xyzf_qmixbz.DSC.L4 + 1       
     .  !CDIR       NODEP                                                       
     .              do t374 = 1, J10                                            
     .                 D9(t374) = D9(t374) + xyzf_qmixbz(t373+J9+t374-1,t370,   
     .       1            t367,t377-1+xyzf_qmixbz.DSC.L4)                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t374 = 1, J10                                               
     .              %000929(J9+t374,t371,t368) = D9(t374)                       
     .           end do                                                         
     .        end do                                                            
     .  !CDIR NODEP                                                             
     .        do J11=0,xyzf_qmixdivmolwt.DSC.U1-xyzf_qmixdivmolwt.DSC.L1,9993   
     .           J12 = min0(xyzf_qmixdivmolwt.DSC.U1 + 1 -                      
     .       1      xyzf_qmixdivmolwt.DSC.L1 - J11,9993)                        
     .  !CDIR    NODEP                                                          
     .           do t417 = 1, J12                                               
     .              D10(t417) = 0.0000000000000000e+000                         
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t420 = 1, xyzf_qmixdivmolwt.DSC.U4 -                        
     .       1      xyzf_qmixdivmolwt.DSC.L4 + 1                                
     .  !CDIR       NODEP                                                       
     .              do t417 = 1, J12                                            
     .                 D10(t417) = D10(t417) + xyzf_qmixdivmolwt(t416+J11+t417-1
     .       1            ,t413,t410,t420-1+xyzf_qmixdivmolwt.DSC.L4)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t417 = 1, J12                                               
     .              %000934(J11+t417,t414,t411) = D10(t417)                     
     .           end do                                                         
     .        end do                                                            
     .        if (xyzf_qmixbz.DSC.U2 + 1 - xyzf_qmixbz.DSC.L2 .gt. 0) then      
     .           J3 = and(xyzf_qmixbz.DSC.U2 + 1 - xyzf_qmixbz.DSC.L2,3)        
     .  !CDIR    NODEP                                                          
     .           do t635 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t637 = 1, xyzf_qmixbz.DSC.U1 + 1 - xyzf_qmixbz.DSC.L1    
     .                 xyz_effmolwtbz(t46+t637-1,t635-1+t48,t633+t50) = (       
     .       1            1.00000000000000e+000 + %000929(t637,t635,t633+1))/(  
     .       2            molwtdry*(1.00000000000000e+000/molwtdry + %000934(   
     .       3            t637,t635,t633+1)))                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t635=J3+1,xyzf_qmixbz.DSC.U2+1-xyzf_qmixbz.DSC.L2,4         
     .  !CDIR       NODEP                                                       
     .              do t637 = 1, xyzf_qmixbz.DSC.U1 + 1 - xyzf_qmixbz.DSC.L1    
     .                 xyz_effmolwtbz(t46+t637-1,t635-1+t48,t633+t50) = (       
     .       1            1.00000000000000e+000 + %000929(t637,t635,t633+1))/(  
     .       2            molwtdry*(1.00000000000000e+000/molwtdry + %000934(   
     .       3            t637,t635,t633+1)))                                   
     .                 xyz_effmolwtbz(t46+t637-1,t635+t48,t633+t50) = (         
     .       1            1.00000000000000e+000 + %000929(t637,t635+1,t633+1))/(
     .       2            molwtdry*(1.00000000000000e+000/molwtdry + %000934(   
     .       3            t637,t635+1,t633+1)))                                 
     .                 xyz_effmolwtbz(t46+t637-1,t635+1+t48,t633+t50) = (       
     .       1            1.00000000000000e+000 + %000929(t637,t635+2,t633+1))/(
     .       2            molwtdry*(1.00000000000000e+000/molwtdry + %000934(   
     .       3            t637,t635+2,t633+1)))                                 
     .                 xyz_effmolwtbz(t46+t637-1,t635+2+t48,t633+t50) = (       
     .       1            1.00000000000000e+000 + %000929(t637,t635+3,t633+1))/(
     .       2            molwtdry*(1.00000000000000e+000/molwtdry + %000934(   
     .       3            t637,t635+3,t633+1)))                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   634        & (1.0d0 + sum(xyzf_QMixBZ,4) ) &
   635        & / ( MolWtDry * ((1.0d0 / MolWtDry) + sum(xyzf_QMixDivMolWt,4)) )
   636  
   637      !Τͤ
   638      !
   639      call SetMargin_xyz( xyz_EffMolWtBZ )
   640  
   641      !---------------------------------------------------------------
   642      ! 
   643      !
   644      xyz_PTempBZ = &
     .        if (t441 .gt. 0) then                                             
     .           J4 = and(t441,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t650 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t652 = 1, t443                                           
     .                 xyz_ptempbz(t13+t652-1,t650-1+t15,t648+t17) = xyz_tempbz(
     .       1            t133+t652-1,t650-1+t135,t648+t137)*(pressbasis/       
     .       2            xyz_pressbz(t35+t652-1,t650-1+t37,t648+t39))**(gasrdry
     .       3            /cpdry)                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t650 = J4 + 1, t441, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t652 = 1, t443                                           
     .                 xyz_ptempbz(t13+t652-1,t650-1+t15,t648+t17) = xyz_tempbz(
     .       1            t133+t652-1,t650-1+t135,t648+t137)*(pressbasis/       
     .       2            xyz_pressbz(t35+t652-1,t650-1+t37,t648+t39))**(gasrdry
     .       3            /cpdry)                                               
     .                 xyz_ptempbz(t13+t652-1,t650+t15,t648+t17) = xyz_tempbz(  
     .       1            t133+t652-1,t650+t135,t648+t137)*(pressbasis/         
     .       2            xyz_pressbz(t35+t652-1,t650+t37,t648+t39))**(gasrdry/ 
     .       3            cpdry)                                                
     .                 xyz_ptempbz(t13+t652-1,t650+1+t15,t648+t17) = xyz_tempbz(
     .       1            t133+t652-1,t650+1+t135,t648+t137)*(pressbasis/       
     .       2            xyz_pressbz(t35+t652-1,t650+1+t37,t648+t39))**(gasrdry
     .       3            /cpdry)                                               
     .                 xyz_ptempbz(t13+t652-1,t650+2+t15,t648+t17) = xyz_tempbz(
     .       1            t133+t652-1,t650+2+t135,t648+t137)*(pressbasis/       
     .       2            xyz_pressbz(t35+t652-1,t650+2+t37,t648+t39))**(gasrdry
     .       3            /cpdry)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   645        & xyz_TempBZ * (PressBasis / xyz_PressBZ) ** (GasRDry / CpDry)
   646  
   647      !Τͤ
   648      !
   649      call SetMargin_xyz( xyz_PTempBZ )
   650  
   651      !---------------------------------------------------------------
   652      ! ʡؿ
   653      !
   654      xyz_ExnerBZ = xyz_TempBZ / xyz_PTempBZ
     .        if (t134 - t135 + 1 .gt. 0) then                                  
     .           J5 = and(t134 - t135 + 1,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t665 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t667 = 1, t132 - t133 + 1                                
     .                 xyz_exnerbz(t155+t667-1,t665-1+t157,t663+t159) =         
     .       1            xyz_tempbz(t133+t667-1,t665-1+t135,t663+t137)/        
     .       2            xyz_ptempbz(t13+t667-1,t665-1+t15,t663+t17)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t665 = J5 + 1, t134 - t135 + 1, 4                           
     .  !CDIR       NODEP                                                       
     .              do t667 = 1, t132 - t133 + 1                                
     .                 xyz_exnerbz(t155+t667-1,t665-1+t157,t663+t159) =         
     .       1            xyz_tempbz(t133+t667-1,t665-1+t135,t663+t137)/        
     .       2            xyz_ptempbz(t13+t667-1,t665-1+t15,t663+t17)           
     .                 xyz_exnerbz(t155+t667-1,t665+t157,t663+t159) = xyz_tempbz
     .       1            (t133+t667-1,t665+t135,t663+t137)/xyz_ptempbz(t13+t667
     .       2            -1,t665+t15,t663+t17)                                 
     .                 xyz_exnerbz(t155+t667-1,t665+1+t157,t663+t159) =         
     .       1            xyz_tempbz(t133+t667-1,t665+1+t135,t663+t137)/        
     .       2            xyz_ptempbz(t13+t667-1,t665+1+t15,t663+t17)           
     .                 xyz_exnerbz(t155+t667-1,t665+2+t157,t663+t159) =         
     .       1            xyz_tempbz(t133+t667-1,t665+2+t135,t663+t137)/        
     .       2            xyz_ptempbz(t13+t667-1,t665+2+t15,t663+t17)           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   655  
   656      !Τͤ
   657      !
   658      call SetMargin_xyz( xyz_ExnerBZ )
   659  
   660      !---------------------------------------------------------------
   661      ! ̩
   662      !
   663      xyz_DensBZ = &
     .        if (t156 - t157 + 1 .gt. 0) then                                  
     .           J6 = and(t156 - t157 + 1,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t680 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t682 = 1, xyz_exnerbz.DSC.U1 - t155 + 1                  
     .                 xyz_densbz(xyz_densbz.DSC.L1+t682-1,t680-1+              
     .       1            xyz_densbz.DSC.L2,t678+xyz_densbz.DSC.L3) = pressbasis
     .       2            *xyz_exnerbz(t155+t682-1,t680-1+t157,t678+t159)**(    
     .       3            cvdry/gasrdry)*xyz_effmolwtbz(t46+t682-1,t680-1+t48,  
     .       4            t678+t50)/(gasrdry*xyz_ptempbz(t13+t682-1,t680-1+t15, 
     .       5            t678+t17))                                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t680 = J6 + 1, t156 - t157 + 1, 4                           
     .  !CDIR       NODEP                                                       
     .              do t682 = 1, xyz_exnerbz.DSC.U1 - t155 + 1                  
     .                 xyz_densbz(xyz_densbz.DSC.L1+t682-1,t680-1+              
     .       1            xyz_densbz.DSC.L2,t678+xyz_densbz.DSC.L3) = pressbasis
     .       2            *xyz_exnerbz(t155+t682-1,t680-1+t157,t678+t159)**(    
     .       3            cvdry/gasrdry)*xyz_effmolwtbz(t46+t682-1,t680-1+t48,  
     .       4            t678+t50)/(gasrdry*xyz_ptempbz(t13+t682-1,t680-1+t15, 
     .       5            t678+t17))                                            
     .                 xyz_densbz(xyz_densbz.DSC.L1+t682-1,t680+                
     .       1            xyz_densbz.DSC.L2,t678+xyz_densbz.DSC.L3) = pressbasis
     .       2            *xyz_exnerbz(t155+t682-1,t680+t157,t678+t159)**(cvdry/
     .       3            gasrdry)*xyz_effmolwtbz(t46+t682-1,t680+t48,t678+t50)/
     .       4            (gasrdry*xyz_ptempbz(t13+t682-1,t680+t15,t678+t17))   
     .                 xyz_densbz(xyz_densbz.DSC.L1+t682-1,t680+1+              
     .       1            xyz_densbz.DSC.L2,t678+xyz_densbz.DSC.L3) = pressbasis
     .       2            *xyz_exnerbz(t155+t682-1,t680+1+t157,t678+t159)**(    
     .       3            cvdry/gasrdry)*xyz_effmolwtbz(t46+t682-1,t680+1+t48,  
     .       4            t678+t50)/(gasrdry*xyz_ptempbz(t13+t682-1,t680+1+t15, 
     .       5            t678+t17))                                            
     .                 xyz_densbz(xyz_densbz.DSC.L1+t682-1,t680+2+              
     .       1            xyz_densbz.DSC.L2,t678+xyz_densbz.DSC.L3) = pressbasis
     .       2            *xyz_exnerbz(t155+t682-1,t680+2+t157,t678+t159)**(    
     .       3            cvdry/gasrdry)*xyz_effmolwtbz(t46+t682-1,t680+2+t48,  
     .       4            t678+t50)/(gasrdry*xyz_ptempbz(t13+t682-1,t680+2+t15, 
     .       5            t678+t17))                                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   664        & PressBasis * (xyz_ExnerBZ ** (CvDry / GasRDry)) &
   665        &  / (GasRDry * xyz_PTempBZ / xyz_EffMolWtBZ)
   666  
   667      !Τͤ
   668      !
   669      call SetMargin_xyz( xyz_DensBZ )
   670  
   671      !---------------------------------------------------------------
   672      ! ®
   673      !
   674      xyz_VelSoundBZ = &
     .        if (t156 - t157 + 1 .gt. 0) then                                  
     .           J7 = and(t156 - t157 + 1,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t698 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t700 = 1, xyz_exnerbz.DSC.U1 + 1 - xyz_exnerbz.DSC.L1    
     .                 xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t700-1,t698-1+      
     .       1            xyz_velsoundbz.DSC.L2,t696+xyz_velsoundbz.DSC.L3) =   
     .       2            dsqrt(cpdry*gasrdry*xyz_exnerbz(t155+t700-1,t698-1+   
     .       3            t157,t696+t159)*xyz_ptempbz(t13+t700-1,t698-1+t15,t696
     .       4            +t17)/(cvdry*xyz_effmolwtbz(t46+t700-1,t698-1+t48,t696
     .       5            +t50)))                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t698 = J7 + 1, t156 - t157 + 1, 4                           
     .  !CDIR       NODEP                                                       
     .              do t700 = 1, xyz_exnerbz.DSC.U1 + 1 - xyz_exnerbz.DSC.L1    
     .                 xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t700-1,t698-1+      
     .       1            xyz_velsoundbz.DSC.L2,t696+xyz_velsoundbz.DSC.L3) =   
     .       2            dsqrt(cpdry*gasrdry*xyz_exnerbz(t155+t700-1,t698-1+   
     .       3            t157,t696+t159)*xyz_ptempbz(t13+t700-1,t698-1+t15,t696
     .       4            +t17)/(cvdry*xyz_effmolwtbz(t46+t700-1,t698-1+t48,t696
     .       5            +t50)))                                               
     .                 xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t700-1,t698+        
     .       1            xyz_velsoundbz.DSC.L2,t696+xyz_velsoundbz.DSC.L3) =   
     .       2            dsqrt(cpdry*gasrdry*xyz_exnerbz(t155+t700-1,t698+t157,
     .       3            t696+t159)*xyz_ptempbz(t13+t700-1,t698+t15,t696+t17)/(
     .       4            cvdry*xyz_effmolwtbz(t46+t700-1,t698+t48,t696+t50)))  
     .                 xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t700-1,t698+1+      
     .       1            xyz_velsoundbz.DSC.L2,t696+xyz_velsoundbz.DSC.L3) =   
     .       2            dsqrt(cpdry*gasrdry*xyz_exnerbz(t155+t700-1,t698+1+   
     .       3            t157,t696+t159)*xyz_ptempbz(t13+t700-1,t698+1+t15,t696
     .       4            +t17)/(cvdry*xyz_effmolwtbz(t46+t700-1,t698+1+t48,t696
     .       5            +t50)))                                               
     .                 xyz_velsoundbz(xyz_velsoundbz.DSC.L1+t700-1,t698+2+      
     .       1            xyz_velsoundbz.DSC.L2,t696+xyz_velsoundbz.DSC.L3) =   
     .       2            dsqrt(cpdry*gasrdry*xyz_exnerbz(t155+t700-1,t698+2+   
     .       3            t157,t696+t159)*xyz_ptempbz(t13+t700-1,t698+2+t15,t696
     .       4            +t17)/(cvdry*xyz_effmolwtbz(t46+t700-1,t698+2+t48,t696
     .       5            +t50)))                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   675        & sqrt ( &
   676        &   CpDry * GasRDry * xyz_ExnerBZ * xyz_PTempBZ &
   677        &   / (CvDry * xyz_EffMolWtBZ) &
   678        & )
   679  
   680      !Τͤ
   681      !
   682      call SetMargin_xyz( xyz_VelSoundBZ )
   683  
   684      !---------------------------------------------------------------
   685      ! 
   686      !
   687      if (CondNum >= 1) then
   688        do s = 1, CondNum
   689          xyzf_HumBZ(:,:,:,IdxCG(s)) = &
     .        if (xyz_pressbz.DSC.U2 - t37 + 1 .gt. 0) then                     
     .           J8 = and(xyz_pressbz.DSC.U2 - t37 + 1,3)                       
     .  !CDIR    NODEP                                                          
     .           do t716 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t718 = 1, xyz_pressbz.DSC.U1 - t35 + 1                   
     .                 xyzf_humbz(xyzf_humbz.DSC.L1+t718-1,t716-1+              
     .       1            xyzf_humbz.DSC.L2,t714+xyzf_humbz.DSC.L3,idxcg(s)) =  
     .       2            xyz_pressbz(t35+t718-1,t716-1+t37,t714+t39)*xyzf_molfr
     .       3            (t84+t718-1,t716-1+t86,t714+t88,idxcg(s))/%000989(    
     .       4            %000989.DSC.L1+t718-1,t716-1+%000989.DSC.L2,t714+     
     .       5            %000989.DSC.L3)*1.00000000000000e+002                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t716 = J8 + 1, xyz_pressbz.DSC.U2 - t37 + 1, 4              
     .  !CDIR       NODEP                                                       
     .              do t718 = 1, xyz_pressbz.DSC.U1 - t35 + 1                   
     .                 xyzf_humbz(xyzf_humbz.DSC.L1+t718-1,t716-1+              
     .       1            xyzf_humbz.DSC.L2,t714+xyzf_humbz.DSC.L3,idxcg(s)) =  
     .       2            xyz_pressbz(t35+t718-1,t716-1+t37,t714+t39)*xyzf_molfr
     .       3            (t84+t718-1,t716-1+t86,t714+t88,idxcg(s))/%000989(    
     .       4            %000989.DSC.L1+t718-1,t716-1+%000989.DSC.L2,t714+     
     .       5            %000989.DSC.L3)*1.00000000000000e+002                 
     .                 xyzf_humbz(xyzf_humbz.DSC.L1+t718-1,t716+                
     .       1            xyzf_humbz.DSC.L2,t714+xyzf_humbz.DSC.L3,idxcg(s)) =  
     .       2            xyz_pressbz(t35+t718-1,t716+t37,t714+t39)*xyzf_molfr( 
     .       3            t84+t718-1,t716+t86,t714+t88,idxcg(s))/%000989(       
     .       4            %000989.DSC.L1+t718-1,t716+%000989.DSC.L2,t714+       
     .       5            %000989.DSC.L3)*1.00000000000000e+002                 
     .                 xyzf_humbz(xyzf_humbz.DSC.L1+t718-1,t716+1+              
     .       1            xyzf_humbz.DSC.L2,t714+xyzf_humbz.DSC.L3,idxcg(s)) =  
     .       2            xyz_pressbz(t35+t718-1,t716+1+t37,t714+t39)*xyzf_molfr
     .       3            (t84+t718-1,t716+1+t86,t714+t88,idxcg(s))/%000989(    
     .       4            %000989.DSC.L1+t718-1,t716+1+%000989.DSC.L2,t714+     
     .       5            %000989.DSC.L3)*1.00000000000000e+002                 
     .                 xyzf_humbz(xyzf_humbz.DSC.L1+t718-1,t716+2+              
     .       1            xyzf_humbz.DSC.L2,t714+xyzf_humbz.DSC.L3,idxcg(s)) =  
     .       2            xyz_pressbz(t35+t718-1,t716+2+t37,t714+t39)*xyzf_molfr
     .       3            (t84+t718-1,t716+2+t86,t714+t88,idxcg(s))/%000989(    
     .       4            %000989.DSC.L1+t718-1,t716+2+%000989.DSC.L2,t714+     
     .       5            %000989.DSC.L3)*1.00000000000000e+002                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   690            & xyz_PressBZ * xyzf_MolFr(:,:,:,IdxCG(s)) &
   691            & / xyz_SvapPress(SpcWetID(IdxCC(s)), xyz_TempBZ) &
   692            & * 100.0d0
   693        end do
   694      end if
   695  
   696      !----------------------------------------------------------
   697      ! BasicSet ⥸塼ͤ
   698      !
   699      call BasicSet_Init(                           &
   700        & xyz_PressBZ, xyz_ExnerBZ, xyz_TempBZ,     &
   701        & xyz_PTempBZ, xyz_DensBZ,  xyz_VelSoundBZ, &
   702        & xyzf_QMixBZ, xyz_EffMolWtBZ )
   703  
   704    end subroutine DetermineBZ
   705  
   706  
   707    subroutine Initialdata_init
   708  
   709      use dc_iounit,     only : FileOpen
   710  
   711      implicit none
   712  
   713      integer                       :: unit     !ֹ
   714  
   715      character(STRING) :: FlagBasic        = ""
   716      character(STRING) :: FlagDisturbPTemp = ""
   717      character(STRING) :: FlagDisturbExner = ""
   718      character(STRING) :: FlagDisturbQMix  = ""
   719      character(STRING) :: FlagDisturbWind  = ""
   720      character(STRING) :: FlagDisturb      = ""
   721  
   722      NAMELIST /initialdata_nml/ &
   723        & FlagBasic,        &
   724        & FlagDisturb,      &
   725        & FlagDisturbPTemp, &
   726        & FlagDisturbExner, &
   727        & FlagDisturbQMix,  &
   728        & FlagDisturbWind
   729  
   730      NAMELIST /initialdata_basic_nml/ &
   731        & Humidity, TempTr, DHight
   732  
   733      NAMELIST /initialdata_disturb_gauss_nml/ &
   734        & PTempMax, ExnerMax, QMixMax, Xc, Xr, Yc, Yr, Zc, Zr
   735  
   736      NAMELIST /initialdata_disturb_random_nml/ &
   737        & PTempMax, ExnerMax, QMixMax, Zpos
   738  
   739      NAMELIST /initialdata_disturb_dryreg_nml/ &
   740        & XposMin, YposMin, ZposMin, XposMax, YposMax, ZposMax
   741  
   742      NAMELIST /initialdata_disturb_moist_nml/ &
   743        & Humidity
   744  
   745      call FileOpen(unit, file=namelist_filename, mode='r')
   746      read(unit, NML=initialdata_nml)
   747      close(unit)
   748  
   749      if (FlagBasic == "Arare4") then
   750        IDBasic = IDBasicArare4
   751      elseif(FlagBasic == "Arare4mmc") then
   752        IDBasic = IDBasicArare4mmc
   753      elseif(FlagBasic == "Yamasaki1983") then
   754        IDBasic = IDBasicYamasaki1983
   755      elseif(FlagBasic == "Takemi2007") then
   756        IDBasic = IDBasicTakemi2007
   757      elseif(FlagBasic == "IsoThermal") then
   758        IDBasic = IDBasicIsoThermal
   759      elseif(FlagBasic == "Dry"       ) then
   760        IDBasic = IDBasicDry
   761      elseif(FlagBasic == "Moist"     ) then
   762        IDBasic = IDBasicMoist
   763      elseif(FlagBasic == "Toon2002"  ) then
   764        IDBasic = IDBasicToon2002
   765      end if
   766  
   767      if(FlagDisturbPTemp == "GaussXY" ) then
   768        IDDisturbPTemp = IDDisturbPTempGaussXY
   769      elseif(FlagDisturbPTemp == "GaussXZ" ) then
   770        IDDisturbPTemp = IDDisturbPTempGaussXZ
   771      elseif(FlagDisturbPTemp == "GaussYZ" ) then
   772        IDDisturbPTemp = IDDisturbPTempGaussYZ
   773      elseif(FlagDisturbPTemp == "GaussXYZ") then
   774        IDDisturbPTemp = IDDisturbPTempGaussXYZ
   775      elseif(FlagDisturbPTemp == "Random"  ) then
   776        IDDisturbPTemp = IDDisturbPTempRandom
   777      end if
   778  
   779      if(FlagDisturbExner == "GaussXY" ) then
   780        IDDisturbExner = IDDisturbExnerGaussXY
   781      elseif(FlagDisturbExner == "GaussXZ" ) then
   782        IDDisturbExner = IDDisturbExnerGaussXZ
   783      elseif(FlagDisturbExner == "GaussYZ" ) then
   784        IDDisturbExner = IDDisturbExnerGaussYZ
   785      elseif(FlagDisturbExner == "GaussXYZ") then
   786        IDDisturbExner = IDDisturbExnerGaussXYZ
   787      end if
   788  
   789      if(FlagDisturbQMix == "GaussXY"  ) then
   790        IDDisturbQMix = IDDisturbQMixGaussXY
   791      elseif(FlagDisturbQMix == "GaussXZ"  ) then
   792        IDDisturbQMix = IDDisturbQMixGaussXZ
   793      elseif(FlagDisturbQMix == "GaussYZ"  ) then
   794        IDDisturbQMix = IDDisturbQMixGaussYZ
   795      elseif(FlagDisturbQMix == "GaussXYZ" ) then
   796        IDDisturbQMix = IDDisturbQMixGaussXYZ
   797      elseif(FlagDisturbQMix == "Dryreg" ) then
   798        IDDisturbQMix = IDDisturbQMixDryreg
   799      elseif(FlagDisturbQMix == "Moist"    ) then
   800        IDDisturbQMix = IDDisturbQMixMoist
   801      end if
   802  
   803      if (FlagDisturbWind == "Takemi2007") then
   804        IDDisturbWind = IDDisturbWindTakemi2007
   805      end if
   806  
   807      if(FlagDisturb == "Arare4"        ) then
   808        IDDisturb = IDDisturbArare4
   809      elseif(FlagDisturb == "Arare4mmc" ) then
   810        IDDisturb = IDDisturbArare4mmc
   811      end if
   812  
   813      !----------------------------------------------------
   814      ! ⥸塼ν
   815      !
   816      !   Yamasaki, ץ, ɬפʤ.
   817      !
   818      select case (IDDisturbPTemp)
   819      case (IDDisturbPTempGaussXY:IDDisturbPTempGaussXYZ)
   820        call FileOpen(unit, file=namelist_filename, mode='r')
   821        read(unit, NML=initialdata_disturb_gauss_nml)
   822        close(unit)
   823  
   824      case (IDDisturbPTempRandom)
   825        call FileOpen(unit, file=namelist_filename, mode='r')
   826        read(unit, NML=initialdata_disturb_random_nml)
   827        close(unit)
   828      end select
   829  
   830      select case (IDDisturbExner)
   831      case (IDDisturbExnerGaussXY:IDDisturbExnerGaussXYZ)
   832        call FileOpen(unit, file=namelist_filename, mode='r')
   833        read(unit, NML=initialdata_disturb_gauss_nml)
   834        close(unit)
   835      end select
   836  
   837      select case (IDDisturbQMix)
   838      case (IDDisturbQMixGaussXY:IDDisturbQMixGaussXYZ)
   839        call FileOpen(unit, file=namelist_filename, mode='r')
   840        read(unit, NML=initialdata_disturb_gauss_nml)
   841        close(unit)
   842  
   843      case(IDDisturbQMixDryreg)
   844        call FileOpen(unit, file=namelist_filename, mode='r')
   845        read(unit, NML=initialdata_disturb_dryreg_nml)
   846        close(unit)
   847  
   848      case(IDDisturbQMixMoist)
   849        call FileOpen(unit, file=namelist_filename, mode='r')
   850        read(unit, NML=initialdata_disturb_moist_nml)
   851        close(unit)
   852      end select
   853  
   854      select case (IDBasic)
   855      case (IDBasicDry, IDBasicMoist)
   856        call FileOpen(unit, file=namelist_filename, mode='r')
   857        read(unit, NML=initialdata_basic_nml)
   858        close(unit)
   859      end select
   860  
   861      if (FlagBasic == "Takemi2007" .OR. FlagDisturbWind == "Takemi2007") then
   862        call initialdata_takemi2007_init
   863      end if
   864  
   865      if (     FlagBasic == "Arare4"        &
   866        & .OR. FlagDisturb == "Arare4"      &
   867        & .OR. FlagBasic   == "Arare4mmc"   &
   868        & .OR. FlagDisturb == "Arare4mmc") then
   869        call arare4fileio_init
   870      end if
   871  
   872      if (myrank == 0) then
   873        call MessageNotify( "M", "main", "FlagBasic        = %c", c1=trim(FlagBasic))
   874        call MessageNotify( "M", "main", "IDBasic          = %d", i=(/IDBasic/))
   875        call MessageNotify( "M", "main", "FlagDisturbPTemp = %c", c1=trim(FlagDisturbPTemp))
   876        call MessageNotify( "M", "main", "IDDisturbPTemp   = %d", i=(/IDDisturbPTemp/))
   877        call MessageNotify( "M", "main", "FlagDisturbExner = %c", c1=trim(FlagDisturbExner))
   878        call MessageNotify( "M", "main", "IDDisturbExner   = %d", i=(/IDDisturbExner/))
   879        call MessageNotify( "M", "main", "FlagDisturbQMix  = %c", c1=trim(FlagDisturbQMix))
   880        call MessageNotify( "M", "main", "IDDisturbQMix    = %d", i=(/IDDisturbQMix/))
   881        call MessageNotify( "M", "main", "FlagDisturb      = %c", c1=trim(FlagDisturb))
   882        call MessageNotify( "M", "main", "IDDisturb        = %d", i=(/IDDisturb/))
   883      end if
   884  
   885    end subroutine Initialdata_init
   886  
   887  
   888  !!!--------------------------------------------------------------
   889    subroutine initialdata_basic_strat(z_TempBZ, z_PressBZ)
   890      !
   891      implicit none
   892  
   893      real(DP), intent(inout) :: z_TempBZ(kmin:kmax)
   894      real(DP), intent(inout) :: z_PressBZ(kmin:kmax)
   895      real(DP)                :: HeightTr
   896      real(DP)                :: z_DTempDZ(kmin:kmax)
   897      real(DP)                :: DTempDZ
   898      real(DP)                :: Weight
   899      integer                 :: k
   900  
   901      do k = 1, kmax
   902        z_DTempDZ(k) = (z_TempBZ(k) - z_TempBZ(k-1)) / z_dz(k-1)
   903      end do
   904  
   905      ! ή
   906      !
   907      HeightTr =  minval(z_z(1:nz), 1, z_TempBZ(1:nz) < TempTr)
   908  
   909      ! ή̤ΰ
   910      !   ̤絤Ȥ. 絤絤ؤܤ
   911      !   tanh ѤƤʤ餫ˤĤʤ
   912      do k = 2, kmax
   913  
   914        !ŤߤĤδؿѰ. tanh Ѥ
   915        Weight = ( tanh( (z_Z(k) - HeightTr ) / Dhight ) + 1.0d0 ) * 5.0d-1
   916  
   917        !ͤȤƲ٤׻. ̤Ǥ TempTr 絤˶Ť
   918        z_TempBZ(k) = z_TempBZ(k) * ( 1.0d0 - Weight ) + TempTr * Weight
   919  
   920        !ٸΨǮٸΨ꾮ʤʤ褦
   921        DTempDZ = max( z_DTempDZ(k), (z_TempBZ(k) - z_TempBZ(k-1)) / z_dz(k-1) )
   922  
   923        !ܾβ٤
   924        z_TempBZ(k) = z_TempBZ(k-1) + DTempDZ * z_dz(k-1)
   925  
   926        !Ϥſ尵ʿդ׻
   927        z_PressBZ(k) =                                          &
   928          &  z_PressBZ(k-1) * ( ( z_TempBZ(k-1) / z_TempBZ(k) ) &
   929          &    ** (Grav / ( DTempDZ * GasRDry ) ) )
   930      end do
   931  
   932    end subroutine initialdata_basic_strat
   933  
   934  
   935    subroutine MainInit
   936  
   937      implicit none
   938  
   939      character(STRING)     :: cfgfile = ""
   940  
   941      ! MPI
   942      !
   943      call MPIWrapperInit
   944  
   945      !NAMELIST ե̾ɤ߹
   946      !
   947      call argset_init(cfgfile) !(out)
   948  
   949      ! NAMELIST ե̾Υ⥸塼ؤϿ
   950      ! Loading NAMELIST file.
   951      !
   952      call NmlutilInit( cfgfile ) !(in)
   953  
   954      !ʻν
   955      !  NAMELIST , ʻ׻
   956      !
   957      call gridset_init
   958  
   959      ! ط׻롼ν
   960      ! Initialization of chemical routines.
   961      !
   962      call chemcalc_init
   963  
   964      ! ξν
   965      ! Initialization of axis variables.
   966      !
   967      call axesset_init
   968  
   969      ! ξν
   970      ! Initialization of constant variables.
   971      !
   972      call constants_init
   973  
   974      ! ͭѿν
   975      ! Initialization of common variables for moist process.
   976      !
   977      call composition_init
   978  
   979      ! I/O ե̾ν
   980      ! Initialization of output file name.
   981      !
   982      call fileset_init
   983  
   984      ! nml Ф (֥롼)
   985      !
   986      call InitialData_init
   987  
   988      !ѿν. ȤꤢͤꤵƤ.
   989      !
   990      call ArareAlloc
   991  
   992    end subroutine MainInit
   993  
   994  end program ArareInitData
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:48 2011
FILE NAME: arare_init-data.f90
PROGRAM NAME: arareinitdata
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Program ArareInitData
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro (̰ϯ), ODAKA Masatsugu ()
     4:            ! Version::   $Id: arare_init-data.f90,v 1.19 2011-06-28 02:29:32 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview 
    10:            !
    11:            ! ϳإǥ deepconv/arare. 
    12:            !
    13:            !== Error Handling
    14:            !
    15:            !== Known Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !  * ϤϽవ̷.
    20:            !
    21:            !== Future Plans
    22:            !
    23:            !
    24:            
    25:            program ArareInitData
    26:              !
    27:              !ϳإǥ deepconv/arare. 
    28:              !
    29:            
    30:              !----- ⥸塼ɤ߹ ------
    31:            
    32:              !-----   , ʸ   ----
    33:              use dc_types,       only : STRING, DP
    34:              use dc_string,      only : StoA
    35:              use gtool_history,  only : HistoryPut
    36:            
    37:              !-----   å   -----
    38:              use dc_message,     only: MessageNotify
    39:            
    40:              !  ޥɥ饤
    41:              use argset,        only : argset_init  
    42:            
    43:              !  MPI ν
    44:              !  Initialize MPI wrapper
    45:              !
    46:              use mpi_wrapper,   only : MPIWrapperInit, MPIWrapperFinalize, myrank
    47:            
    48:              !-----    ⥸塼   -----
    49:              !  ϥե̾⥸塼
    50:              use fileset,    only : fileset_init
    51:            
    52:              !  ʻ⥸塼 
    53:              use gridset, only : gridset_init, &
    54:                &                       imin, imax, jmin, jmax, kmin, kmax, &
    55:                &                       nx, ny, nz,  ncmax
    56:            
    57:              !  ܾ⥸塼
    58:              use basicset,      only : basicset_init
    59:            
    60:              use axesset,       only : axesset_init
    61:            
    62:              use constants,     only : constants_init, molwtdry, &
    63:                &                       Grav, TempSfc, PressSfc, &
    64:                &                       pressbasis, gasrdry, cpdry, cvdry
    65:            
    66:              !  롼⥸塼
    67:              use composition,      only: composition_init, molwtwet, SpcWetMolFr, &
    68:                &                       GasNum, CondNum, IdxCC, IdxCG, SpcWetID
    69:            
    70:              ! ط׻
    71:              use ChemCalc, only: ChemCalc_init, xyz_SvapPress
    72:            
    73:              !  Ŭѥ⥸塼
    74:              use setmargin
    75:            
    76:              use axesset, only:  z_Z,          &!顼ʻǤι
    77:                &                 z_dz            !Z γʻֳ
    78:            
    79:              use namelist_util, only: NmlutilInit, namelist_filename
    80:            
    81:              use eccm,     only: ECCM_Dry,      &!
    82:                &                 ECCM_Wet              
    83:            
    84:              use initialdata_disturb, only: &
    85:                &  initialdata_disturb_random,  &
    86:                &  initialdata_disturb_gaussXZ, initialdata_disturb_gaussXY, &
    87:                &  initialdata_disturb_gaussYZ, initialdata_disturb_gaussXYZ, &
    88:                &  initialdata_disturb_dryreg, initialdata_disturb_moist
    89:              use initialdata_yamasaki1983, only: initialdata_yamasaki1983_basic
    90:              use initialdata_takemi2007, only: initialdata_takemi2007_init, &
    91:                &  initialdata_takemi2007_basic, initialdata_takemi2007_wind
    92:              use initialdata_toon2002, only: initialdata_toon2002_basic
    93:            
    94:              !-----    ϥ⥸塼   -----
    95:              !  ꥹȥեϥ⥸塼
    96:              use RestartFileIO, only : ReStartFileIO_Init, ReStartFileIO_Finalize, rstat
    97:              use Arare4FileIO,  only : Arare4FileIO_Init, Arare4FileIO_Var_Get, Arare4FileIO_BZ_Get, &
    98:                &                       Arare4FileIO_MMC_Var_Get, Arare4FileIO_MMC_BZ_Get
    99:            
   100:              !ۤηػ
   101:              implicit none
   102:            
   103:              !ѿ
   104:              real(DP), allocatable :: pyz_VelX(:,:,:)
   105:              real(DP), allocatable :: xqz_VelY(:,:,:)
   106:              real(DP), allocatable :: xyr_VelZ(:,:,:)
   107:              real(DP), allocatable :: xyz_Exner(:,:,:)
   108:              real(DP), allocatable :: xyz_PTemp(:,:,:)
   109:              real(DP), allocatable :: xyz_Km(:,:,:)
   110:              real(DP), allocatable :: xyz_Kh(:,:,:)
   111:              real(DP), allocatable :: xyz_CDens(:,:,:)
   112:              real(DP), allocatable :: xyzf_QMix(:,:,:,:)
   113:              real(DP), allocatable :: xyz_DensBZ(:,:,:)
   114:              real(DP), allocatable :: xyz_PressBZ(:,:,:)
   115:              real(DP), allocatable :: xyz_ExnerBZ(:,:,:)
   116:              real(DP), allocatable :: xyz_TempBZ(:,:,:)
   117:              real(DP), allocatable :: xyz_PTempBZ(:,:,:)
   118:              real(DP), allocatable :: xyz_VelSoundBZ(:,:,:)
   119:              real(DP), allocatable :: xyzf_QMixBZ(:,:,:,:)
   120:              real(DP), allocatable :: xyz_EffMolWtBZ(:,:,:)
   121:              real(DP), allocatable :: z_TempBZ(:)
   122:              real(DP), allocatable :: z_PressBZ(:)
   123:              real(DP), allocatable :: xyzf_MolFr(:,:,:,:)
   124:              real(DP), allocatable :: zf_MolFr(:,:)
   125:              real(DP), allocatable :: xyzf_QMixDivMolWt(:,:,:,:)
   126:              real(DP), allocatable :: xyzf_HumBZ(:,:,:,:)
   127:              real(DP)              :: Time
   128:              integer               :: i, j, k, s
   129:            
   130:              !ѿ
   131:              ! Moist 
   132:              real(DP)   :: Humidity = 0.0d0 !м
   133:              ! Gauss 
   134:              real(DP)   :: PTempMax = 0.0d0 !
   135:              real(DP)   :: ExnerMax = 0.0d0 !
   136:              real(DP)   :: QMixMax = 0.0d0  !
   137:              real(DP)   :: Xc = 0.0d0       !濴(X)
   138:              real(DP)   :: Yc = 0.0d0       !濴(Y)
   139:              real(DP)   :: Zc = 0.0d0       !濴(ľ)
   140:              real(DP)   :: Xr = 0.0d0       !Ⱦ(X)
   141:              real(DP)   :: Yr = 0.0d0       !Ⱦ(Y)
   142:              real(DP)   :: Zr = 0.0d0       !Ⱦ(ľ)
   143:              ! Therma-Random 
   144:              real(DP)   :: Zpos = 0.0d0     ! Z ɸ [m] 
   145:              ! Dryreg 
   146:              real(DP)   :: XposMin = 0.0d0    ! X ɸ [m] 
   147:              real(DP)   :: YposMin = 0.0d0    ! Y ɸ [m] 
   148:              real(DP)   :: ZposMin = 0.0d0    ! Z ɸ [m] 
   149:              real(DP)   :: XposMax = 0.0d0    ! X ɸ [m] 
   150:              real(DP)   :: YposMax = 0.0d0    ! Y ɸ [m] 
   151:              real(DP)   :: ZposMax = 0.0d0    ! Z ɸ [m] 
   152:            
   153:              real(DP)   :: TempTr = 100.0d0     !ή̤β [k]
   154:              real(DP)   :: Dhight = 10.0d3       !ŤߴؿΥѥ᡼ [m]
   155:            
   156:              integer               :: IDBasic                = 0
   157:              integer, parameter    :: IDBasicArare4          = 1
   158:              integer, parameter    :: IDBasicArare4mmc       = 2
   159:              integer, parameter    :: IDBasicYamasaki1983    = 3
   160:              integer, parameter    :: IDBasicTakemi2007      = 4
   161:              integer, parameter    :: IDBasicIsoThermal      = 5
   162:              integer, parameter    :: IDBasicDry             = 6
   163:              integer, parameter    :: IDBasicMoist           = 7
   164:              integer, parameter    :: IDBasicToon2002        = 8
   165:              integer               :: IDDisturbPTemp         = 0
   166:              integer, parameter    :: IDDisturbPTempGaussXY  = 1
   167:              integer, parameter    :: IDDisturbPTempGaussXZ  = 2
   168:              integer, parameter    :: IDDisturbPTempGaussYZ  = 3
   169:              integer, parameter    :: IDDisturbPTempGaussXYZ = 4
   170:              integer, parameter    :: IDDisturbPTempRandom   = 5
   171:              integer               :: IDDisturbExner         = 0
   172:              integer, parameter    :: IDDisturbExnerGaussXY  = 1
   173:              integer, parameter    :: IDDisturbExnerGaussXZ  = 2
   174:              integer, parameter    :: IDDisturbExnerGaussYZ  = 3
   175:              integer, parameter    :: IDDisturbExnerGaussXYZ = 4
   176:              integer               :: IDDisturbQMix          = 0
   177:              integer, parameter    :: IDDisturbQMixGaussXY   = 1
   178:              integer, parameter    :: IDDisturbQMixGaussXZ   = 2
   179:              integer, parameter    :: IDDisturbQMixGaussYZ   = 3
   180:              integer, parameter    :: IDDisturbQMixGaussXYZ  = 4
   181:              integer, parameter    :: IDDisturbQMixDryreg    = 5
   182:              integer, parameter    :: IDDisturbQMixMoist     = 6
   183:              integer               :: IDDisturbWind          = 0
   184:              integer, parameter    :: IDDisturbWindTakemi2007= 1
   185:              integer               :: IDDisturb              = 0
   186:              integer, parameter    :: IDDisturbArare4        = 1
   187:              integer, parameter    :: IDDisturbArare4mmc     = 2
   188:              
   189:            
   190:              !------------------------------------------
   191:              ! ³ ; Initialize procedure 
   192:              !
   193:              call MainInit
   194:            
   195:              Time = 0.0d0
   196:              call MessageNotify( "M", "main", "Making Initial data...." )
   197:            
   198:              !---------------------------------------------------------------  
   199:              ! ܾ. 
   200:              !
   201:              select case(IDBasic)
   202:                
   203:              case (IDBasicArare4)
   204:                ! deepconv/arare4 Υҥȥ꡼ե뤫ͤɤ߹
   205:                !
   206:                call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   207:                call Arare4fileio_BZ_Get( &
   208:                  & xyz_PressBZ,   & ! (out)
   209:                  & xyz_ExnerBZ,   & ! (out)
   210:                  & xyz_TempBZ,    & ! (out)
   211:                  & xyz_PTempBZ,   & ! (out)
   212:                  & xyz_DensBZ,    & ! (out)
   213:                  & xyz_VelSoundBZ,& ! (out)
   214:                  & xyzf_QMixBZ,   & ! (out)
   215:                  & xyz_EffMolWtBZ & ! (out)
   216:                  & )
   217:            
   218:              case (IDBasicArare4mmc)
   219:                ! deepconv/arare4 ǤΥҥȥ꡼ե뤫ͤɤ߹
   220:                !    
   221:                call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   222:            
   223:                call Arare4fileio_MMC_BZ_Get( &
   224:                  & xyz_PressBZ,   & ! (out)
   225:                  & xyz_ExnerBZ,   & ! (out)
   226:                  & xyz_TempBZ,    & ! (out)
   227:                  & xyz_PTempBZ,   & ! (out)
   228:                  & xyz_DensBZ,    & ! (out)
   229:                  & xyz_VelSoundBZ,& ! (out)
   230:                  & xyzf_QMixBZ,   & ! (out)
   231:                  & xyz_EffMolWtBZ & ! (out)
   232:                  & )
   233:                
   234:              case(IDBasicIsoThermal) 
   235:                ! /Ϲθʤ
   236:                !  
   237:                call MessageNotify( "M", "main", "Making Initial data (basic) named IsoThermal..." )
   238:                
   239: V======        z_TempBZ = TempSfc
   240: V======        z_PressBZ = PressSfc
   241: W+=====        zf_MolFr = 0.0d0
   242:                
   243:                ! Ĥδܾͤ
   244:                call DetermineBZ            
   245:            
   246:              case(IDBasicDry) 
   247:                ! ǮŪʽ
   248:                !
   249:                call MessageNotify( "M", "main", "Making Initial data (basic) named DRY..." )
   250:                call eccm_dry( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, zf_MolFr )
   251: V======        if (minval(z_TempBZ(1:nz)) < TempTr) then 
   252:                  call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   253:                end if
   254:                
   255:                ! Ĥδܾͤ
   256:                call DetermineBZ            
   257:                
   258:            ! ǥХåѤǤʤ
   259:            !   
   260:            !  case(IDBasicMoist) 
   261:            !    ! ǮŪʽ
   262:            !    !
   263:            !    call MessageNotify( "M", "main", "Making Initial data (basic) named MOIST..." )
   264:            !    call eccm_wet( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, zf_MolFr )
   265:            !    call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   266:            !
   267:            !    ! Ĥδܾͤ
   268:            !    call DetermineBZ            
   269:            
   270:              case(IDBasicToon2002) 
   271:                ! 
   272:                !
   273:                call MessageNotify( "M", "main", "Making Initial data (basic) named Toon et al. 2002..." )
   274:                call initialdata_toon2002_basic( z_TempBZ, z_PressBZ ) !(out)
   275:            !    call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
   276:            
   277:                ! Ĥδܾͤ
   278:                call DetermineBZ            
   279:                
   280:              case(IDBasicTakemi2007)
   281:                ! Takemi(2007)δܾѤ
   282:                !
   283:                call MessageNotify( "M", "main", "Making Initial data named Takemi2007..." )
   284:                call initialdata_takemi2007_basic( z_TempBZ, z_PressBZ, zf_MolFr )
   285:            
   286:                ! Ĥδܾͤ
   287:                call DetermineBZ            
   288:            
   289:              case(IDBasicYamasaki1983) 
   290:                ! Yamasaki(1983)β٤м٤δ¬ͤѤ 
   291:                !
   292:                call MessageNotify( "M", "main", "Making Initial data named Yamasaki1983..." )
   293:                call initialdata_yamasaki1983_basic( z_TempBZ, z_PressBZ, zf_MolFr )
   294:                
   295:                ! Ĥδܾͤ
   296:                call DetermineBZ            
   297:            
   298:              end select
   299:            
   300:              !---------------------------------------------------------
   301:              ! ͤ
   302:              ! 
   303:            
   304:              ! : ͤ
   305:              !    
   306:              select case(IDDisturbPTemp)
   307:            
   308:              case(IDDisturbPTempGaussXY)
   309:                ! : ʬۤͿ (XY)
   310:                !          
   311:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   312:                call initialdata_disturb_gaussXY(PTempMax, Xc, Xr, Yc, Yr, xyz_PTemp)
   313:                call SetMargin_xyz( xyz_PTemp )
   314:            
   315:              case(IDDisturbPTempGaussXZ)
   316:                ! : ʬۤͿ (XZ)
   317:                !                
   318:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   319:                call initialdata_disturb_gaussXZ(PTempMax, Xc, Xr, Zc, Zr, xyz_PTemp)
   320:                call SetMargin_xyz( xyz_PTemp )
   321:            
   322:              case(IDDisturbPTempGaussYZ)
   323:                ! : ʬۤͿ (YZ)
   324:                !                
   325:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   326:                call initialdata_disturb_gaussYZ(PTempMax, Yc, Yr, Zc, Zr, xyz_PTemp)
   327:                call SetMargin_xyz( xyz_PTemp )
   328:            
   329:              case(IDDisturbPTempGaussXYZ)
   330:                ! : ʬۤͿ (XYZ)
   331:                !                   
   332:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   333:                call initialdata_disturb_gaussXYZ(PTempMax, Xc, Xr, Yc, Yr, Zc, Zr, xyz_PTemp)
   334:                call SetMargin_xyz( xyz_PTemp )
   335:            
   336:              case(IDDisturbPTempRandom)
   337:                ! : ꤵ줿٤˥ʬۤͿ. 
   338:                !                      
   339:                call MessageNotify( "M", "main", "Making Initial data (disturb) named random..." )
   340:                call initialdata_disturb_random(PTempMax, Zpos, xyz_PTemp)
   341:                call SetMargin_xyz( xyz_PTemp )
   342:                
   343:              end select
   344:            
   345:              
   346:              ! ʡؿ: ͤ    
   347:              !                
   348:              select case(IDDisturbExner)
   349:            
   350:              case(IDDisturbExnerGaussXY)
   351:                ! ʡؿ: ʬۤͿ (XY)
   352:                !                         
   353:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   354:                call initialdata_disturb_gaussXY(ExnerMax, Xc, Xr, Yc, Yr, xyz_Exner)
   355:                call SetMargin_xyz( xyz_Exner )
   356:            
   357:              case(IDDisturbExnerGaussXZ)
   358:                ! ʡؿ: ʬۤͿ (XZ)
   359:                !                            
   360:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   361:                call initialdata_disturb_gaussXZ(ExnerMax, Xc, Xr, Zc, Zr, xyz_Exner)
   362:                call SetMargin_xyz( xyz_Exner )
   363:            
   364:              case(IDDisturbExnerGaussYZ)
   365:                ! ʡؿ: ʬۤͿ (YZ)
   366:                !                            
   367:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   368:                call initialdata_disturb_gaussYZ(ExnerMax, Yc, Yr, Zc, Zr, xyz_Exner)
   369:                call SetMargin_xyz( xyz_Exner )
   370:            
   371:              case(IDDisturbExnerGaussXYZ)      
   372:                ! ʡؿ: ʬۤͿ (XYZ)
   373:                !                      
   374:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   375:                call initialdata_disturb_gaussXYZ(ExnerMax, Xc, Xr, Yc, Yr, Zc, Zr, xyz_Exner)
   376:                call SetMargin_xyz( xyz_Exner )
   377:            
   378:              end select
   379:            
   380:            
   381:              ! : ͤ
   382:              !                    
   383:              select case(IDDisturbQMix)
   384:            
   385:              case(IDDisturbQMixGaussXY)
   386:                ! : ʬۤͿ (XY)
   387:                !                               
   388:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
   389:                call initialdata_disturb_gaussXY(QMixMax, Xc, Xr, Yc, Yr, xyzf_QMix(:,:,:,1))
   390:                call SetMargin_xyzf( xyzf_QMix )
   391:                
   392:              case(IDDisturbQMixGaussXZ)
   393:                ! : ʬۤͿ (XZ)
   394:                !                                      
   395:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
   396:                call initialdata_disturb_gaussXZ(QMixMax, Xc, Xr, Zc, Zr, xyzf_QMix(:,:,:,1))
   397:                call SetMargin_xyzf( xyzf_QMix )
   398:            
   399:              case(IDDisturbQMixGaussYZ)
   400:                ! : ʬۤͿ (YZ)
   401:                !                                      
   402:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussYZ..." )
   403:                call initialdata_disturb_gaussYZ(QMixMax, Yc, Yr, Zc, Zr, xyzf_QMix(:,:,:,1))
   404:                call SetMargin_xyzf( xyzf_QMix )
   405:            
   406:              case(IDDisturbQMixGaussXYZ)
   407:                ! : ʬۤͿ (XYZ)
   408:                !                                      
   409:                call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
   410:                call initialdata_disturb_gaussXYZ(QMixMax, Xc, Xr, Yc, Yr, Zc, Zr, xyzf_QMix(:,:,:,1))
   411:                call SetMargin_xyzf( xyzf_QMix )
   412:            
   413:              case(IDDisturbQMixDryreg)
   414:                ! : ΰ
   415:                !                            
   416:                call MessageNotify( "M", "main", "Making Initial data (disturb) named Dryreg..." )
   417:                call initialdata_disturb_dryreg(  &
   418:                  & XposMin, XposMax, YposMin, YposMax, ZposMin, ZposMax, xyzf_QMix)
   419:                call SetMargin_xyzf( xyzf_QMix )
   420:            
   421:              case(IDDisturbQMixMoist)
   422:                ! : ǮŪʬۤͿ 
   423:                !                                  
   424:                call MessageNotify( "M", "main", "Making Initial data (disturb) named MOIST..." )
   425:                call initialdata_disturb_moist(Humidity, xyzf_QMix)
   426:                call SetMargin_xyzf( xyzf_QMix )
   427:                
   428:              end select
   429:            
   430:              ! : ®پͤ
   431:              !                    
   432:              select case(IDDisturbWind)  
   433:              case (IDDisturbWindTakemi2007)  
   434:                ! Takemi (2007) ®ʬ
   435:                !
   436:                call MessageNotify( "M", "main", "Making Initial data (disturb) named Wind takemi2007..." )
   437:                call initialdata_takemi2007_wind( pyz_VelX ) 
   438:                call SetMargin_pyz( pyz_VelX )   
   439:            
   440:              end select
   441:            
   442:              ! 礷ƾͿ
   443:              !
   444:              select case(IDDisturb)  
   445:              case (IDDisturbArare4)    
   446:                call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   447:                call Arare4fileio_Var_Get( &
   448:                  & pyz_VelX,     & ! (out)
   449:                  & xqz_VelY,     & ! (out)
   450:                  & xyr_VelZ,     & ! (out)
   451:                  & xyz_PTemp,    & ! (out)
   452:                  & xyz_Exner,    & ! (out)
   453:                  & xyzf_QMix,    & ! (out)
   454:                  & xyz_Km,       & ! (out)
   455:                  & xyz_Kh,       & ! (out)
   456:                  & xyz_CDens   )   ! (out)
   457:            
   458:              case (IDDisturbArare4mmc)    
   459:                call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
   460:                call Arare4fileio_MMC_Var_Get( &
   461:                  & pyz_VelX,     & ! (out)
   462:                  & xqz_VelY,     & ! (out)
   463:                  & xyr_VelZ,     & ! (out)
   464:                  & xyz_PTemp,    & ! (out)
   465:                  & xyz_Exner,    & ! (out)
   466:                  & xyzf_QMix,    & ! (out)
   467:                  & xyz_Km,       & ! (out)
   468:                  & xyz_Kh,       & ! (out)
   469:                  & xyz_CDens   )   ! (out)
   470:              end select
   471:            
   472:              !------------------------------------------------
   473:              ! ե
   474:              !
   475:              call MessageNotify( "M", "main", "Output variables into netCDF file..." )
   476:            
   477:              ! ꥹȥե. ܾȾ. 
   478:              !
   479:              call ReStartFileIO_Init
   480:            
   481:              call HistoryPut( 't',     Time,      rstat)
   482:              call HistoryPut( 'VelX',  pyz_VelX,  rstat)
   483:              call HistoryPut( 'VelY',  xqz_VelY,  rstat)
   484:              call HistoryPut( 'VelZ',  xyr_VelZ,  rstat)
   485:              call HistoryPut( 'Exner', xyz_Exner, rstat)
   486:              call HistoryPut( 'PTemp', xyz_PTemp, rstat)
   487:              call HistoryPut( 'Km',    xyz_Km,    rstat)
   488:              call HistoryPut( 'Kh',    xyz_Kh,    rstat)
   489:              call HistoryPut( 'QMix',  xyzf_QMix, rstat)    
   490:              call HistoryPut( 'CDens', xyz_CDens, rstat)    
   491:            
   492:              ! ܾΥե
   493:              !
   494:              call HistoryPut( 'DensBZ',     xyz_DensBZ    , rstat)
   495:              call HistoryPut( 'ExnerBZ',    xyz_ExnerBZ   , rstat)
   496:              call HistoryPut( 'PTempBZ',    xyz_PTempBZ   , rstat)
   497:              call HistoryPut( 'VelSoundBZ', xyz_VelSoundBZ, rstat)
   498:              call HistoryPut( 'TempBZ',     xyz_TempBZ    , rstat)
   499:              call HistoryPut( 'PressBZ',    xyz_PressBZ   , rstat)
   500:              call HistoryPut( 'QMixBZ',     xyzf_QMixBZ   , rstat)
   501:              call HistoryPut( 'EffMolWtBZ', xyz_EffMolWtBZ, rstat)
   502:              call HistoryPut( 'HumBZ',      xyzf_HumBZ    , rstat)
   503:              
   504:              call ReStartFileIO_Finalize
   505:            
   506:              !----------------------------------------------------
   507:              ! MPI END
   508:              !
   509:              call MPIWrapperFinalize
   510:              
   511:            contains
   512:            
   513:              subroutine ArareAlloc
   514:                !
   515:                !Ȥ, , ͤȤƥ.
   516:                !
   517:            
   518:                !ۤηػ
   519:                implicit none
   520:            
   521:                !
   522:                allocate( pyz_VelX(imin:imax, jmin:jmax, kmin:kmax) )
   523:                allocate( xqz_VelY(imin:imax, jmin:jmax, kmin:kmax) )
   524:                allocate( xyr_VelZ(imin:imax, jmin:jmax, kmin:kmax) )
   525:                allocate( xyz_Exner(imin:imax, jmin:jmax, kmin:kmax) )
   526:                allocate( xyz_PTemp(imin:imax, jmin:jmax, kmin:kmax) )
   527:                allocate( xyz_Km(imin:imax, jmin:jmax, kmin:kmax) )
   528:                allocate( xyz_Kh(imin:imax, jmin:jmax, kmin:kmax) )
   529:                allocate( xyz_CDens(imin:imax, jmin:jmax, kmin:kmax) )
   530:                allocate( xyzf_QMix(imin:imax, jmin:jmax, kmin:kmax, ncmax) )
   531:            
   532:                allocate( xyz_DensBZ(imin:imax,jmin:jmax,kmin:kmax))
   533:                allocate( xyz_PressBZ(imin:imax,jmin:jmax,kmin:kmax))
   534:                allocate( xyz_ExnerBZ(imin:imax,jmin:jmax,kmin:kmax))
   535:                allocate( xyz_TempBZ(imin:imax,jmin:jmax,kmin:kmax))
   536:                allocate( xyz_PTempBZ(imin:imax,jmin:jmax,kmin:kmax))
   537:                allocate( xyz_VelSoundBZ(imin:imax,jmin:jmax,kmin:kmax))
   538:                allocate( xyzf_QMixBZ(imin:imax,jmin:jmax,kmin:kmax,ncmax))
   539:                allocate( xyz_EffMolWtBZ(imin:imax,jmin:jmax,kmin:kmax))
   540:                allocate( z_TempBZ(kmin:kmax))
   541:                allocate( z_PressBZ(kmin:kmax))
   542:                allocate( xyzf_MolFr(imin:imax, jmin:jmax, kmin:kmax, ncmax))
   543:                allocate( zf_MolFr(kmin:kmax, ncmax))
   544:                allocate( xyzf_QMixDivMolWt(imin:imax,jmin:jmax,kmin:kmax, ncmax))
   545:                allocate( xyzf_HumBZ(imin:imax,jmin:jmax,kmin:kmax, ncmax))
   546:            
   547: WWW====        pyz_VelX = 0.0d0
   548: WWW====        xqz_VelY = 0.0d0
   549: WWW====        xyr_VelZ = 0.0d0
   550: WWW====        xyz_PTemp = 0.0d0
   551: WWW====        xyz_Exner = 0.0d0
   552: WW+====        xyz_Km = 0.0d0
   553: +++====        xyz_Kh = 0.0d0
   554: +++====        xyz_CDens = 0.0d0
   555: ++++===        xyzf_QMix = 0.0d0
   556:            
   557: +++====        xyz_DensBZ = 0.0d0
   558: +++====        xyz_PressBZ = 0.0d0
   559: +++====        xyz_ExnerBZ = 0.0d0
   560: +++====        xyz_TempBZ = 0.0d0
   561: +++====        xyz_PTempBZ = 0.0d0
   562: +++====        xyz_VelSoundBZ = 0.0d0
   563: ++++===        xyzf_QMixBZ = 0.0d0
   564: +++====        xyz_EffMolWtBZ  = 0.0d0
   565: V======        z_TempBZ  = 0.0d0
   566: V======        z_PressBZ = 0.0d0
   567: WWWW===        xyzf_MolFr = 0.0d0
   568: **=====        zf_MolFr = 0.0d0 
   569: ****===        xyzf_QMixDivMolWt = 0.0d0
   570: ****===        xyzf_HumBZ = 0.0d0
   571:            
   572:              end subroutine ArareAlloc
   573:                
   574:            
   575:              subroutine DetermineBZ
   576:            
   577:                !---------------------------------------------------------------
   578:                ! ١
   579:                !
   580:            
   581:                ! 3 ˳Ǽ
   582: +------>       do k = 1, nz
   583: |+----->         do j = 1, ny
   584: ||V---->           do i = 1, nx
   585: |||                  xyz_TempBZ(i,j,k)  = z_TempBZ(k)  
   586: |||                  xyz_PressBZ(i,j,k) = z_PressBZ(k)
   587: ||V----            end do
   588: |+-----          end do
   589: +------        end do
   590:                
   591:                !Τͤ
   592:                !
   593:                call SetMargin_xyz( xyz_TempBZ )
   594:                call SetMargin_xyz( xyz_PressBZ)
   595:            
   596:                !---------------------------------------------------------------
   597:                ! 
   598:                !
   599:                !ʿˤϰ
   600: +------>       do k = 1, nz
   601: |+----->         do j = 1, ny
   602: ||+---->           do i = 1, nx
   603: |||V===              xyzf_MolFr(i,j,k,:) = zf_MolFr(k,:)
   604: ||+----            end do
   605: |+-----          end do
   606: +------        end do
   607:            
   608:                !Τͤ
   609:                ! 
   610:                call SetMargin_xyzf( xyzf_MolFr )
   611:            
   612:                !Υ򺮹Ѵ
   613: +------>       do s = 1, ncmax
   614: |++V===          xyzf_QMixBZ(:,:,:,s) = xyzf_MolFr(:,:,:,s) * MolWtWet(s) / MolWtDry
   615: +------        end do
   616:                
   617:                !  !ͤʤꤹʤ褦˺ͤͿ
   618:                !  where (xyzf_QMixBZ <= 1.0d-20 )
   619:                !    xyzf_QMixBZ = 1.0d-20
   620:                !  end where
   621:                
   622:                !Τͤ
   623:                !
   624:                call SetMargin_xyzf( xyzf_QMixBZ )
   625:                
   626:                !---------------------------------------------------------------
   627:                ! ʬ̤θ
   628:                !
   629: +------>       do s = 1, ncmax
   630: |++V===          xyzf_QMixDivMolWt(:,:,:,s) = xyzf_QMixBZ(:,:,:,s) / MolWtWet(s)
   631: +------        end do
   632:                
   633: +++V===        xyz_EffMolWtBZ = &
   634:                  & (1.0d0 + sum(xyzf_QMixBZ,4) ) &
   635:                  & / ( MolWtDry * ((1.0d0 / MolWtDry) + sum(xyzf_QMixDivMolWt,4)) )
   636:                
   637:                !Τͤ  
   638:                !
   639:                call SetMargin_xyz( xyz_EffMolWtBZ )
   640:                
   641:                !---------------------------------------------------------------    
   642:                ! 
   643:                !
   644: ++V====        xyz_PTempBZ = &
   645:                  & xyz_TempBZ * (PressBasis / xyz_PressBZ) ** (GasRDry / CpDry) 
   646:            
   647:                !Τͤ  
   648:                !
   649:                call SetMargin_xyz( xyz_PTempBZ )
   650:                
   651:                !---------------------------------------------------------------    
   652:                ! ʡؿ
   653:                !
   654: ++V====        xyz_ExnerBZ = xyz_TempBZ / xyz_PTempBZ    
   655:                
   656:                !Τͤ
   657:                !
   658:                call SetMargin_xyz( xyz_ExnerBZ )
   659:            
   660:                !---------------------------------------------------------------    
   661:                ! ̩
   662:                !    
   663: ++V====        xyz_DensBZ = &
   664:                  & PressBasis * (xyz_ExnerBZ ** (CvDry / GasRDry)) &
   665:                  &  / (GasRDry * xyz_PTempBZ / xyz_EffMolWtBZ)
   666:                
   667:                !Τͤ
   668:                !
   669:                call SetMargin_xyz( xyz_DensBZ )
   670:                
   671:                !---------------------------------------------------------------    
   672:                ! ®
   673:                !
   674: ++V====        xyz_VelSoundBZ = &
   675:                  & sqrt ( &
   676:                  &   CpDry * GasRDry * xyz_ExnerBZ * xyz_PTempBZ &
   677:                  &   / (CvDry * xyz_EffMolWtBZ) &
   678:                  & )
   679:                
   680:                !Τͤ
   681:                !
   682:                call SetMargin_xyz( xyz_VelSoundBZ )
   683:            
   684:                !---------------------------------------------------------------    
   685:                ! 
   686:                !
   687:                if (CondNum >= 1) then 
   688: +------>         do s = 1, CondNum
   689: |++V===            xyzf_HumBZ(:,:,:,IdxCG(s)) = &
   690: |                    & xyz_PressBZ * xyzf_MolFr(:,:,:,IdxCG(s)) &
   691: |                    & / xyz_SvapPress(SpcWetID(IdxCC(s)), xyz_TempBZ) &
   692: |                    & * 100.0d0
   693: +------          end do
   694:                end if
   695:            
   696:                !----------------------------------------------------------
   697:                ! BasicSet ⥸塼ͤ
   698:                !
   699:                call BasicSet_Init(                           &
   700:                  & xyz_PressBZ, xyz_ExnerBZ, xyz_TempBZ,     &
   701:                  & xyz_PTempBZ, xyz_DensBZ,  xyz_VelSoundBZ, &
   702:                  & xyzf_QMixBZ, xyz_EffMolWtBZ )
   703:                
   704:              end subroutine DetermineBZ
   705:            
   706:            
   707:              subroutine Initialdata_init
   708:            
   709:                use dc_iounit,     only : FileOpen    
   710:            
   711:                implicit none
   712:            
   713:                integer                       :: unit     !ֹ
   714:            
   715:                character(STRING) :: FlagBasic        = ""
   716:                character(STRING) :: FlagDisturbPTemp = ""
   717:                character(STRING) :: FlagDisturbExner = ""
   718:                character(STRING) :: FlagDisturbQMix  = ""
   719:                character(STRING) :: FlagDisturbWind  = ""
   720:                character(STRING) :: FlagDisturb      = ""
   721:            
   722:                NAMELIST /initialdata_nml/ &
   723:                  & FlagBasic,        & 
   724:                  & FlagDisturb,      &
   725:                  & FlagDisturbPTemp, &    
   726:                  & FlagDisturbExner, &    
   727:                  & FlagDisturbQMix,  &    
   728:                  & FlagDisturbWind  
   729:            
   730:                NAMELIST /initialdata_basic_nml/ &
   731:                  & Humidity, TempTr, DHight
   732:            
   733:                NAMELIST /initialdata_disturb_gauss_nml/ &
   734:                  & PTempMax, ExnerMax, QMixMax, Xc, Xr, Yc, Yr, Zc, Zr
   735:            
   736:                NAMELIST /initialdata_disturb_random_nml/ &
   737:                  & PTempMax, ExnerMax, QMixMax, Zpos
   738:            
   739:                NAMELIST /initialdata_disturb_dryreg_nml/ &
   740:                  & XposMin, YposMin, ZposMin, XposMax, YposMax, ZposMax
   741:            
   742:                NAMELIST /initialdata_disturb_moist_nml/ &
   743:                  & Humidity
   744:            
   745:                call FileOpen(unit, file=namelist_filename, mode='r')
   746:                read(unit, NML=initialdata_nml)
   747:                close(unit)
   748:            
   749:                if (FlagBasic == "Arare4") then 
   750:                  IDBasic = IDBasicArare4
   751:                elseif(FlagBasic == "Arare4mmc") then 
   752:                  IDBasic = IDBasicArare4mmc
   753:                elseif(FlagBasic == "Yamasaki1983") then 
   754:                  IDBasic = IDBasicYamasaki1983
   755:                elseif(FlagBasic == "Takemi2007") then 
   756:                  IDBasic = IDBasicTakemi2007
   757:                elseif(FlagBasic == "IsoThermal") then 
   758:                  IDBasic = IDBasicIsoThermal
   759:                elseif(FlagBasic == "Dry"       ) then 
   760:                  IDBasic = IDBasicDry
   761:                elseif(FlagBasic == "Moist"     ) then 
   762:                  IDBasic = IDBasicMoist
   763:                elseif(FlagBasic == "Toon2002"  ) then 
   764:                  IDBasic = IDBasicToon2002
   765:                end if
   766:            
   767:                if(FlagDisturbPTemp == "GaussXY" ) then     
   768:                  IDDisturbPTemp = IDDisturbPTempGaussXY
   769:                elseif(FlagDisturbPTemp == "GaussXZ" ) then     
   770:                  IDDisturbPTemp = IDDisturbPTempGaussXZ
   771:                elseif(FlagDisturbPTemp == "GaussYZ" ) then     
   772:                  IDDisturbPTemp = IDDisturbPTempGaussYZ
   773:                elseif(FlagDisturbPTemp == "GaussXYZ") then     
   774:                  IDDisturbPTemp = IDDisturbPTempGaussXYZ
   775:                elseif(FlagDisturbPTemp == "Random"  ) then     
   776:                  IDDisturbPTemp = IDDisturbPTempRandom
   777:                end if
   778:            
   779:                if(FlagDisturbExner == "GaussXY" ) then     
   780:                  IDDisturbExner = IDDisturbExnerGaussXY 
   781:                elseif(FlagDisturbExner == "GaussXZ" ) then     
   782:                  IDDisturbExner = IDDisturbExnerGaussXZ 
   783:                elseif(FlagDisturbExner == "GaussYZ" ) then     
   784:                  IDDisturbExner = IDDisturbExnerGaussYZ 
   785:                elseif(FlagDisturbExner == "GaussXYZ") then    
   786:                  IDDisturbExner = IDDisturbExnerGaussXYZ  
   787:                end if
   788:            
   789:                if(FlagDisturbQMix == "GaussXY"  ) then     
   790:                  IDDisturbQMix = IDDisturbQMixGaussXY
   791:                elseif(FlagDisturbQMix == "GaussXZ"  ) then 
   792:                  IDDisturbQMix = IDDisturbQMixGaussXZ   
   793:                elseif(FlagDisturbQMix == "GaussYZ"  ) then 
   794:                  IDDisturbQMix = IDDisturbQMixGaussYZ   
   795:                elseif(FlagDisturbQMix == "GaussXYZ" ) then 
   796:                  IDDisturbQMix = IDDisturbQMixGaussXYZ    
   797:                elseif(FlagDisturbQMix == "Dryreg" ) then
   798:                  IDDisturbQMix = IDDisturbQMixDryreg
   799:                elseif(FlagDisturbQMix == "Moist"    ) then    
   800:                  IDDisturbQMix = IDDisturbQMixMoist
   801:                end if
   802:            
   803:                if (FlagDisturbWind == "Takemi2007") then
   804:                  IDDisturbWind = IDDisturbWindTakemi2007
   805:                end if
   806:            
   807:                if(FlagDisturb == "Arare4"        ) then    
   808:                  IDDisturb = IDDisturbArare4
   809:                elseif(FlagDisturb == "Arare4mmc" ) then    
   810:                  IDDisturb = IDDisturbArare4mmc
   811:                end if
   812:            
   813:                !----------------------------------------------------
   814:                ! ⥸塼ν
   815:                !
   816:                !   Yamasaki, ץ, ɬפʤ. 
   817:                !
   818:                select case (IDDisturbPTemp)
   819:                case (IDDisturbPTempGaussXY:IDDisturbPTempGaussXYZ)
   820:                  call FileOpen(unit, file=namelist_filename, mode='r')
   821:                  read(unit, NML=initialdata_disturb_gauss_nml)
   822:                  close(unit)
   823:            
   824:                case (IDDisturbPTempRandom)
   825:                  call FileOpen(unit, file=namelist_filename, mode='r')
   826:                  read(unit, NML=initialdata_disturb_random_nml)
   827:                  close(unit)
   828:                end select
   829:            
   830:                select case (IDDisturbExner)
   831:                case (IDDisturbExnerGaussXY:IDDisturbExnerGaussXYZ)
   832:                  call FileOpen(unit, file=namelist_filename, mode='r')
   833:                  read(unit, NML=initialdata_disturb_gauss_nml)
   834:                  close(unit)
   835:                end select
   836:            
   837:                select case (IDDisturbQMix)
   838:                case (IDDisturbQMixGaussXY:IDDisturbQMixGaussXYZ)
   839:                  call FileOpen(unit, file=namelist_filename, mode='r')
   840:                  read(unit, NML=initialdata_disturb_gauss_nml)
   841:                  close(unit)
   842:            
   843:                case(IDDisturbQMixDryreg)
   844:                  call FileOpen(unit, file=namelist_filename, mode='r')
   845:                  read(unit, NML=initialdata_disturb_dryreg_nml)
   846:                  close(unit)
   847:            
   848:                case(IDDisturbQMixMoist)
   849:                  call FileOpen(unit, file=namelist_filename, mode='r')
   850:                  read(unit, NML=initialdata_disturb_moist_nml)
   851:                  close(unit)
   852:                end select
   853:            
   854:                select case (IDBasic)
   855:                case (IDBasicDry, IDBasicMoist)
   856:                  call FileOpen(unit, file=namelist_filename, mode='r')
   857:                  read(unit, NML=initialdata_basic_nml)
   858:                  close(unit)
   859:                end select
   860:            
   861:                if (FlagBasic == "Takemi2007" .OR. FlagDisturbWind == "Takemi2007") then 
   862:                  call initialdata_takemi2007_init
   863:                end if
   864:            
   865:                if (     FlagBasic == "Arare4"        &
   866:                  & .OR. FlagDisturb == "Arare4"      &
   867:                  & .OR. FlagBasic   == "Arare4mmc"   &
   868:                  & .OR. FlagDisturb == "Arare4mmc") then 
   869:                  call arare4fileio_init
   870:                end if
   871:            
   872:                if (myrank == 0) then 
   873:                  call MessageNotify( "M", "main", "FlagBasic        = %c", c1=trim(FlagBasic))
   874:                  call MessageNotify( "M", "main", "IDBasic          = %d", i=(/IDBasic/))
   875:                  call MessageNotify( "M", "main", "FlagDisturbPTemp = %c", c1=trim(FlagDisturbPTemp))
   876:                  call MessageNotify( "M", "main", "IDDisturbPTemp   = %d", i=(/IDDisturbPTemp/))
   877:                  call MessageNotify( "M", "main", "FlagDisturbExner = %c", c1=trim(FlagDisturbExner))
   878:                  call MessageNotify( "M", "main", "IDDisturbExner   = %d", i=(/IDDisturbExner/))
   879:                  call MessageNotify( "M", "main", "FlagDisturbQMix  = %c", c1=trim(FlagDisturbQMix))
   880:                  call MessageNotify( "M", "main", "IDDisturbQMix    = %d", i=(/IDDisturbQMix/))
   881:                  call MessageNotify( "M", "main", "FlagDisturb      = %c", c1=trim(FlagDisturb))
   882:                  call MessageNotify( "M", "main", "IDDisturb        = %d", i=(/IDDisturb/))
   883:                end if
   884:            
   885:              end subroutine Initialdata_init
   886:            
   887:            
   888:            !!!--------------------------------------------------------------
   889:              subroutine initialdata_basic_strat(z_TempBZ, z_PressBZ)
   890:                !
   891:                implicit none
   892:                
   893:                real(DP), intent(inout) :: z_TempBZ(kmin:kmax)
   894:                real(DP), intent(inout) :: z_PressBZ(kmin:kmax)
   895:                real(DP)                :: HeightTr
   896:                real(DP)                :: z_DTempDZ(kmin:kmax)
   897:                real(DP)                :: DTempDZ
   898:                real(DP)                :: Weight
   899:                integer                 :: k    
   900:                
   901: V------>       do k = 1, kmax
   902: |                z_DTempDZ(k) = (z_TempBZ(k) - z_TempBZ(k-1)) / z_dz(k-1)
   903: V------        end do
   904:            
   905:                ! ή
   906:                !
   907: V======        HeightTr =  minval(z_z(1:nz), 1, z_TempBZ(1:nz) < TempTr)
   908:                
   909:                ! ή̤ΰ
   910:                !   ̤絤Ȥ. 絤絤ؤܤ 
   911:                !   tanh ѤƤʤ餫ˤĤʤ
   912: V------>       do k = 2, kmax
   913: |                
   914: |                !ŤߤĤδؿѰ. tanh Ѥ
   915: |                Weight = ( tanh( (z_Z(k) - HeightTr ) / Dhight ) + 1.0d0 ) * 5.0d-1
   916: |                
   917: |                !ͤȤƲ٤׻. ̤Ǥ TempTr 絤˶Ť
   918: |                z_TempBZ(k) = z_TempBZ(k) * ( 1.0d0 - Weight ) + TempTr * Weight
   919: |                
   920: |                !ٸΨǮٸΨ꾮ʤʤ褦
   921: |       S        DTempDZ = max( z_DTempDZ(k), (z_TempBZ(k) - z_TempBZ(k-1)) / z_dz(k-1) )
   922: |       S        
   923: |       S        !ܾβ٤
   924: |       S        z_TempBZ(k) = z_TempBZ(k-1) + DTempDZ * z_dz(k-1) 
   925: |       S        
   926: |       S        !Ϥſ尵ʿդ׻
   927: |       S        z_PressBZ(k) =                                          &
   928: |                  &  z_PressBZ(k-1) * ( ( z_TempBZ(k-1) / z_TempBZ(k) ) &
   929: |                  &    ** (Grav / ( DTempDZ * GasRDry ) ) )
   930: V------        end do
   931:                
   932:              end subroutine initialdata_basic_strat
   933:            
   934:            
   935:              subroutine MainInit
   936:            
   937:                implicit none
   938:            
   939:                character(STRING)     :: cfgfile = ""    
   940:            
   941:                ! MPI
   942:                !
   943:                call MPIWrapperInit
   944:                
   945:                !NAMELIST ե̾ɤ߹
   946:                !
   947:                call argset_init(cfgfile) !(out)
   948:                
   949:                ! NAMELIST ե̾Υ⥸塼ؤϿ
   950:                ! Loading NAMELIST file.
   951:                !
   952:                call NmlutilInit( cfgfile ) !(in)
   953:                
   954:                !ʻν
   955:                !  NAMELIST , ʻ׻
   956:                !
   957:                call gridset_init
   958:                
   959:                ! ط׻롼ν
   960:                ! Initialization of chemical routines.
   961:                !
   962:                call chemcalc_init
   963:                
   964:                ! ξν
   965:                ! Initialization of axis variables.
   966:                !
   967:                call axesset_init
   968:                
   969:                ! ξν
   970:                ! Initialization of constant variables.
   971:                !
   972:                call constants_init
   973:                
   974:                ! ͭѿν
   975:                ! Initialization of common variables for moist process.
   976:                !
   977:                call composition_init
   978:                
   979:                ! I/O ե̾ν
   980:                ! Initialization of output file name. 
   981:                !
   982:                call fileset_init
   983:                
   984:                ! nml Ф (֥롼)
   985:                !
   986:                call InitialData_init
   987:            
   988:                !ѿν. ȤꤢͤꤵƤ. 
   989:                !
   990:                call ArareAlloc  
   991:                
   992:              end subroutine MainInit
   993:            
   994:            end program ArareInitData
